/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/
using System;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace symmetry
{
	/// <summary>
	/// Summary description for ColorChanger.
	/// </summary>
	public class ColorChanger
	{
		public ColorChanger()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		~ColorChanger()
		{
			
		}

		public Color colorize(double cc)
		{
		
			double cblu = 0,cred = 0,cgre = 0;
		
			
				cblu = bluefunc(cc);
				cred = redfunc(cc);
				cgre =  1 - Math.Pow(redfunc(cc+0.1),2) - bluefunc(cc-0.15);
		
			return Color.FromArgb((int)(cred*255),(int)(cgre*255),(int)(cblu*255));		
			
		}

	
		private double bluefunc(double cc)
		{
			return (1.0 / (1.0 + Math.Exp(-10*(cc-0.6))));
		}

		private double redfunc(double cc)
		{
			return (1.0/(1.0 + Math.Exp(10*(cc-0.5))));
		}

		public Color svetlost(Color c,double svet)
		{
					
			c = Color.FromArgb((int)(255*svet),(int)(c.R),(int)(c.G),(int)(c.B));
			return c;
		}

		public Color saturacija(Color c,double saturacija)
		{
			double avg = 0.0;
			
			avg = (c.R+c.B+c.G)/3;
		
			c = Color.FromArgb((int)(avg + (c.R-avg)*saturacija),
							   (int)(avg + (c.G-avg)*saturacija),
							   (int)(avg + (c.B-avg)*saturacija));
			
			return c;	
		}

		public double colorToDouble(Color c)
		{
			
			double rez = 0.0;
            
			rez = ((-(c.ToArgb()/1777216))*2)-1;
			return rez;

		}

	}
}
