
/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Drawing.Drawing2D;
using System.Threading;
using System.Diagnostics;

namespace symmetry
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private System.ComponentModel.IContainer components = null;
	
		private bool mouseDown = false;
		private int[] rightMouseButtonDown = new int[100]; //tukaj imamo spravljen indeks tocke,ki jo premikamo
		private int[] stStroka = new int[100];			//stevilka Strok-a v katerem je tocka, ki jo premikamo
		private bool zeNarisanObjekt= false;  //spremenljivka, ki nam pove kam dodajamo narisane tocke
		private bool clikMedTockami = false;
		private Point lastPoint = Point.Empty;
		private static string color = "Black";
		private static Graphics g;
		private Pen p;
	
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.Button button3;
		private System.Windows.Forms.Button button4;
		private System.Windows.Forms.Button button5;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Button button6;
		private System.Windows.Forms.Button button7;
		private System.Windows.Forms.Button button8;
		private System.Windows.Forms.Button button9;
		private System.Windows.Forms.Button button10;
		private System.Windows.Forms.Button button11;
		private System.Windows.Forms.Button button12;
		private System.Windows.Forms.Button button13;
		private System.Windows.Forms.Button button14;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.Button button15;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.StatusBar statusBar1;
		
		private static int pen_width = 1;
		private Strokes1 allStrokes = new Strokes1();    //seznam vseh objetkov
		private System.Windows.Forms.Button button16;
		private Stroke1 oneStroke = new Stroke1();		//seznam tock posameznega objekta
		private int objectNumber = 0;
	
		private System.Windows.Forms.StatusBarPanel statusBarPanel1;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem menuItem9;
		private System.Windows.Forms.MenuItem menuItem10;
		private System.Windows.Forms.MenuItem menuItem11;
		private System.Windows.Forms.MenuItem menuItem12;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.HScrollBar hScrollBar1;
		private System.Windows.Forms.VScrollBar vScrollBar1;
		private System.Windows.Forms.Button button17;
		private System.Windows.Forms.MenuItem menuItem13;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.MenuItem menuItem14;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.Panel panel5;
		private System.Windows.Forms.Panel panel6;				
		
		private bool buttonEraser = false;				//raderke ne bomo posebaj beleili
		private int LastScroll_V = 0;						//zadnja pozicija scrollbar-ov
		private int LastScroll_H = 0;
		
		private System.Windows.Forms.MenuItem menuItem15;
		private System.Windows.Forms.MenuItem menuItem16;
		private System.Windows.Forms.MenuItem menuItem17;
		private System.Windows.Forms.MenuItem menuItem18;
		private System.Windows.Forms.MenuItem menuItem20;
		private System.Windows.Forms.MenuItem menuItem19;
		private System.Windows.Forms.MenuItem menuItem21;
		
		private Recognizer rr = new Recognizer();		
		private Set_corner s;
	
		private double barva = -1;
		private double svetlost = 0;
		private double saturacija = 0;
		
		private double StartTicks = 0.0;			//timer spremenljivke
		private double EndTicks = 0.0;
		private double cumTime = 0.0;
		private HiPerfTimer hpt;
		
		private Recognizer2 recog = new Recognizer2();		
	
      
		private Line l = new Line();							//dodatno dolocanje kotov v panel2_MouseUp
		private int indexG = 0;
		private int indexD = 0;
		private static Strokes1 resitveStroki = new Strokes1();
		private Stroke1  enStroke = new Stroke1();
		private Point lastAddedPoint = Point.Empty;				//tocka za racunanje razdalje "enStroke" med dvema sosednjima tockama 
		private int st_tock = 0;
		private System.Windows.Forms.Button button18;								//stevec tock mouse_move
		private Constraints cos = new Constraints();
		static Thread simSileThread = new Thread(new ThreadStart(simulirajSile));
		private bool Start_Stop_Force_Simulation = false;
		
		//seznam konstant za sile
		public static float omejitevHitrosti = 0.001f; 
		public static long   casovniKorak = 100;
		public static float gKonstanta = -1.0f;
		public static int	smerGravSile = 90;
		public static float silaCirculalWall = 15.0f;
		private System.Windows.Forms.MenuItem menuItem22;
		public static float   radijCirculalWall = 5f;
		private System.Windows.Forms.MenuItem menuItem23;
		
		public static bool narisiMrezo = false;
		private System.Windows.Forms.MenuItem menuItem3;
		public static int sirinaVisinaMreze = 10;
		public static int Hitrost_recognizer = 100;
		private System.Windows.Forms.MenuItem menuItem24;
		public static int razdaljaMedOgli = 3;
		private System.Windows.Forms.MenuItem menuItem25;
		public static int razdaljaMedStikalisciTock =   14;
		private System.Windows.Forms.MenuItem menuItem26;
		public static bool vstaviText = false;
		public static bool stringAliInk = false;
		public static String text = null;
		public static Stroke1 ink = null;
		private int desniKlik = -1;
		private System.Windows.Forms.MenuItem menuItem27;
		private int cifraStroka = -1;
		public static bool krivulja = false;
			 
		
	
		

			
		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
	
				
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		
		

	
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Configuration.AppSettingsReader configurationAppSettings = new System.Configuration.AppSettingsReader();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem14 = new System.Windows.Forms.MenuItem();
			this.menuItem13 = new System.Windows.Forms.MenuItem();
			this.menuItem12 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem26 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem19 = new System.Windows.Forms.MenuItem();
			this.menuItem21 = new System.Windows.Forms.MenuItem();
			this.menuItem23 = new System.Windows.Forms.MenuItem();
			this.menuItem27 = new System.Windows.Forms.MenuItem();
			this.menuItem15 = new System.Windows.Forms.MenuItem();
			this.menuItem20 = new System.Windows.Forms.MenuItem();
			this.menuItem16 = new System.Windows.Forms.MenuItem();
			this.menuItem17 = new System.Windows.Forms.MenuItem();
			this.menuItem18 = new System.Windows.Forms.MenuItem();
			this.menuItem22 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem24 = new System.Windows.Forms.MenuItem();
			this.menuItem25 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.menuItem9 = new System.Windows.Forms.MenuItem();
			this.menuItem11 = new System.Windows.Forms.MenuItem();
			this.menuItem10 = new System.Windows.Forms.MenuItem();
			this.panel3 = new System.Windows.Forms.Panel();
			this.button16 = new System.Windows.Forms.Button();
			this.button15 = new System.Windows.Forms.Button();
			this.button14 = new System.Windows.Forms.Button();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.button13 = new System.Windows.Forms.Button();
			this.button12 = new System.Windows.Forms.Button();
			this.button11 = new System.Windows.Forms.Button();
			this.button10 = new System.Windows.Forms.Button();
			this.button9 = new System.Windows.Forms.Button();
			this.button8 = new System.Windows.Forms.Button();
			this.button7 = new System.Windows.Forms.Button();
			this.button6 = new System.Windows.Forms.Button();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.button17 = new System.Windows.Forms.Button();
			this.button5 = new System.Windows.Forms.Button();
			this.button4 = new System.Windows.Forms.Button();
			this.button3 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.button1 = new System.Windows.Forms.Button();
			this.panel2 = new System.Windows.Forms.Panel();
			this.vScrollBar1 = new System.Windows.Forms.VScrollBar();
			this.hScrollBar1 = new System.Windows.Forms.HScrollBar();
			this.statusBar1 = new System.Windows.Forms.StatusBar();
			this.statusBarPanel1 = new System.Windows.Forms.StatusBarPanel();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.panel4 = new System.Windows.Forms.Panel();
			this.panel5 = new System.Windows.Forms.Panel();
			this.panel6 = new System.Windows.Forms.Panel();
			this.button18 = new System.Windows.Forms.Button();
			this.groupBox2.SuspendLayout();
			this.groupBox1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).BeginInit();
			this.panel4.SuspendLayout();
			this.panel5.SuspendLayout();
			this.panel6.SuspendLayout();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem2,
																					  this.menuItem7,
																					  this.menuItem15,
																					  this.menuItem8});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem5,
																					  this.menuItem14,
																					  this.menuItem13,
																					  this.menuItem12,
																					  this.menuItem4});
			this.menuItem1.Text = "File";
			this.menuItem1.Popup += new System.EventHandler(this.menuItem1_Popup);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 0;
			this.menuItem5.Text = "New";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// menuItem14
			// 
			this.menuItem14.Index = 1;
			this.menuItem14.Text = "Open";
			this.menuItem14.Click += new System.EventHandler(this.menuItem14_Click);
			// 
			// menuItem13
			// 
			this.menuItem13.Index = 2;
			this.menuItem13.Text = "Save As ...";
			this.menuItem13.Click += new System.EventHandler(this.menuItem13_Click_1);
			// 
			// menuItem12
			// 
			this.menuItem12.Index = 3;
			this.menuItem12.Text = "-";
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 4;
			this.menuItem4.Text = "Exit";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 1;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem6,
																					  this.menuItem26});
			this.menuItem2.Text = "Edit";
			this.menuItem2.Popup += new System.EventHandler(this.menuItem1_Popup);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 0;
			this.menuItem6.Text = "Undo";
			this.menuItem6.Click += new System.EventHandler(this.menuItem6_Click);
			// 
			// menuItem26
			// 
			this.menuItem26.Index = 1;
			this.menuItem26.Text = "Insert Text";
			this.menuItem26.Click += new System.EventHandler(this.menuItem26_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 2;
			this.menuItem7.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem19,
																					  this.menuItem21,
																					  this.menuItem23,
																					  this.menuItem27});
			this.menuItem7.Text = "View";
			this.menuItem7.Popup += new System.EventHandler(this.menuItem1_Popup);
			// 
			// menuItem19
			// 
			this.menuItem19.Index = 0;
			this.menuItem19.Text = "Left Hand";
			this.menuItem19.Click += new System.EventHandler(this.menuItem19_Click);
			// 
			// menuItem21
			// 
			this.menuItem21.Checked = true;
			this.menuItem21.Index = 1;
			this.menuItem21.Text = "Right Hand";
			this.menuItem21.Click += new System.EventHandler(this.menuItem21_Click);
			// 
			// menuItem23
			// 
			this.menuItem23.Index = 2;
			this.menuItem23.Text = "Draw Grid";
			this.menuItem23.Click += new System.EventHandler(this.menuItem23_Click);
			// 
			// menuItem27
			// 
			this.menuItem27.Index = 3;
			this.menuItem27.RadioCheck = true;
			this.menuItem27.Text = "Show Dependences";
			this.menuItem27.Click += new System.EventHandler(this.menuItem27_Click);
			// 
			// menuItem15
			// 
			this.menuItem15.Index = 3;
			this.menuItem15.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItem20,
																					   this.menuItem16,
																					   this.menuItem25});
			this.menuItem15.Text = "Tools";
			this.menuItem15.Popup += new System.EventHandler(this.menuItem1_Popup);
			// 
			// menuItem20
			// 
			this.menuItem20.Index = 0;
			this.menuItem20.Text = "Draw Graph";
			this.menuItem20.Visible = false;
			this.menuItem20.Click += new System.EventHandler(this.menuItem20_Click);
			// 
			// menuItem16
			// 
			this.menuItem16.Index = 1;
			this.menuItem16.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					   this.menuItem17,
																					   this.menuItem18,
																					   this.menuItem22,
																					   this.menuItem3,
																					   this.menuItem24});
			this.menuItem16.Text = "Settings";
			// 
			// menuItem17
			// 
			this.menuItem17.Index = 0;
			this.menuItem17.Text = "Set Corner";
			this.menuItem17.Click += new System.EventHandler(this.menuItem17_Click);
			// 
			// menuItem18
			// 
			this.menuItem18.Index = 1;
			this.menuItem18.Text = "Set Line";
			this.menuItem18.Click += new System.EventHandler(this.menuItem18_Click);
			// 
			// menuItem22
			// 
			this.menuItem22.Index = 2;
			this.menuItem22.Text = "Set Forces";
			this.menuItem22.Click += new System.EventHandler(this.menuItem22_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 3;
			this.menuItem3.Text = "Set Grid";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem24
			// 
			this.menuItem24.Index = 4;
			this.menuItem24.Text = "Set Recognizer";
			this.menuItem24.Click += new System.EventHandler(this.menuItem24_Click);
			// 
			// menuItem25
			// 
			this.menuItem25.Index = 2;
			this.menuItem25.Text = "Test input data";
			this.menuItem25.Click += new System.EventHandler(this.menuItem25_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 4;
			this.menuItem8.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem9,
																					  this.menuItem11,
																					  this.menuItem10});
			this.menuItem8.Text = "Help";
			this.menuItem8.Visible = false;
			this.menuItem8.Popup += new System.EventHandler(this.menuItem1_Popup);
			// 
			// menuItem9
			// 
			this.menuItem9.Index = 0;
			this.menuItem9.Text = "Help Topics";
			// 
			// menuItem11
			// 
			this.menuItem11.Index = 1;
			this.menuItem11.Text = "-";
			// 
			// menuItem10
			// 
			this.menuItem10.Index = 2;
			this.menuItem10.Text = "About";
			// 
			// panel3
			// 
			this.panel3.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this.panel3.BackColor = System.Drawing.Color.Black;
			this.panel3.Location = new System.Drawing.Point(35, 136);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(24, 24);
			this.panel3.TabIndex = 5;
			// 
			// button16
			// 
			this.button16.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this.button16.Enabled = false;
			this.button16.ForeColor = System.Drawing.Color.Black;
			this.button16.Location = new System.Drawing.Point(10, 360);
			this.button16.Name = "button16";
			this.button16.Size = new System.Drawing.Size(72, 23);
			this.button16.TabIndex = 4;
			this.button16.Text = "Objects";
			this.button16.Visible = false;
			this.button16.Click += new System.EventHandler(this.button16_Click);
			// 
			// button15
			// 
			this.button15.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this.button15.ForeColor = System.Drawing.Color.Black;
			this.button15.Location = new System.Drawing.Point(10, 296);
			this.button15.Name = "button15";
			this.button15.Size = new System.Drawing.Size(72, 23);
			this.button15.TabIndex = 3;
			this.button15.Text = "Eraser";
			this.button15.Visible = false;
			this.button15.Click += new System.EventHandler(this.button15_Click);
			// 
			// button14
			// 
			this.button14.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this.button14.BackColor = System.Drawing.SystemColors.Control;
			this.button14.ForeColor = System.Drawing.Color.Black;
			this.button14.Location = new System.Drawing.Point(10, 328);
			this.button14.Name = "button14";
			this.button14.Size = new System.Drawing.Size(72, 23);
			this.button14.TabIndex = 2;
			this.button14.Text = "Clear";
			this.button14.Click += new System.EventHandler(this.button14_Click);
			// 
			// groupBox2
			// 
			this.groupBox2.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this.groupBox2.BackColor = System.Drawing.SystemColors.Control;
			this.groupBox2.Controls.Add(this.button13);
			this.groupBox2.Controls.Add(this.button12);
			this.groupBox2.Controls.Add(this.button11);
			this.groupBox2.Controls.Add(this.button10);
			this.groupBox2.Controls.Add(this.button9);
			this.groupBox2.Controls.Add(this.button8);
			this.groupBox2.Controls.Add(this.button7);
			this.groupBox2.Controls.Add(this.button6);
			this.groupBox2.Location = new System.Drawing.Point(10, 168);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(72, 120);
			this.groupBox2.TabIndex = 1;
			this.groupBox2.TabStop = false;
			// 
			// button13
			// 
			this.button13.BackColor = System.Drawing.Color.Sienna;
			this.button13.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button13.ForeColor = System.Drawing.Color.Transparent;
			this.button13.Location = new System.Drawing.Point(8, 64);
			this.button13.Name = "button13";
			this.button13.Size = new System.Drawing.Size(20, 20);
			this.button13.TabIndex = 7;
			this.button13.Click += new System.EventHandler(this.button13_Click);
			// 
			// button12
			// 
			this.button12.BackColor = System.Drawing.Color.Aqua;
			this.button12.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button12.ForeColor = System.Drawing.Color.Transparent;
			this.button12.Location = new System.Drawing.Point(8, 16);
			this.button12.Name = "button12";
			this.button12.Size = new System.Drawing.Size(20, 20);
			this.button12.TabIndex = 6;
			this.button12.Click += new System.EventHandler(this.button12_Click);
			// 
			// button11
			// 
			this.button11.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button11.BackColor = System.Drawing.Color.Yellow;
			this.button11.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button11.ForeColor = System.Drawing.Color.Transparent;
			this.button11.Location = new System.Drawing.Point(40, 16);
			this.button11.Name = "button11";
			this.button11.Size = new System.Drawing.Size(20, 20);
			this.button11.TabIndex = 5;
			this.button11.Click += new System.EventHandler(this.button11_Click);
			// 
			// button10
			// 
			this.button10.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button10.BackColor = System.Drawing.Color.Red;
			this.button10.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button10.ForeColor = System.Drawing.Color.Transparent;
			this.button10.Location = new System.Drawing.Point(40, 40);
			this.button10.Name = "button10";
			this.button10.Size = new System.Drawing.Size(20, 20);
			this.button10.TabIndex = 4;
			this.button10.Click += new System.EventHandler(this.button10_Click);
			// 
			// button9
			// 
			this.button9.BackColor = System.Drawing.Color.MediumBlue;
			this.button9.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button9.ForeColor = System.Drawing.Color.Transparent;
			this.button9.Location = new System.Drawing.Point(8, 88);
			this.button9.Name = "button9";
			this.button9.Size = new System.Drawing.Size(20, 20);
			this.button9.TabIndex = 3;
			this.button9.Click += new System.EventHandler(this.button9_Click);
			// 
			// button8
			// 
			this.button8.BackColor = System.Drawing.Color.Silver;
			this.button8.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button8.ForeColor = System.Drawing.Color.Transparent;
			this.button8.Location = new System.Drawing.Point(8, 40);
			this.button8.Name = "button8";
			this.button8.Size = new System.Drawing.Size(20, 20);
			this.button8.TabIndex = 2;
			this.button8.Click += new System.EventHandler(this.button8_Click);
			// 
			// button7
			// 
			this.button7.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button7.BackColor = System.Drawing.Color.LawnGreen;
			this.button7.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button7.ForeColor = System.Drawing.Color.Transparent;
			this.button7.Location = new System.Drawing.Point(40, 64);
			this.button7.Name = "button7";
			this.button7.Size = new System.Drawing.Size(20, 20);
			this.button7.TabIndex = 1;
			this.button7.Click += new System.EventHandler(this.button7_Click);
			// 
			// button6
			// 
			this.button6.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.button6.BackColor = System.Drawing.Color.Black;
			this.button6.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button6.ForeColor = System.Drawing.Color.Transparent;
			this.button6.Location = new System.Drawing.Point(40, 88);
			this.button6.Name = "button6";
			this.button6.Size = new System.Drawing.Size(20, 20);
			this.button6.TabIndex = 0;
			this.button6.Click += new System.EventHandler(this.button6_Click);
			// 
			// groupBox1
			// 
			this.groupBox1.AccessibleDescription = ((string)(configurationAppSettings.GetValue("groupBox1.AccessibleDescription", typeof(string))));
			this.groupBox1.AccessibleName = ((string)(configurationAppSettings.GetValue("groupBox1.AccessibleName", typeof(string))));
			this.groupBox1.Anchor = System.Windows.Forms.AnchorStyles.Top;
			this.groupBox1.BackColor = System.Drawing.SystemColors.Control;
			this.groupBox1.CausesValidation = ((bool)(configurationAppSettings.GetValue("groupBox1.CausesValidation", typeof(bool))));
			this.groupBox1.Controls.Add(this.button17);
			this.groupBox1.Controls.Add(this.button5);
			this.groupBox1.Controls.Add(this.button4);
			this.groupBox1.Controls.Add(this.button3);
			this.groupBox1.Controls.Add(this.button2);
			this.groupBox1.Controls.Add(this.button1);
			this.groupBox1.Enabled = ((bool)(configurationAppSettings.GetValue("groupBox1.Enabled", typeof(bool))));
			this.groupBox1.ForeColor = System.Drawing.SystemColors.ControlText;
			this.groupBox1.Location = new System.Drawing.Point(10, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(72, 112);
			this.groupBox1.TabIndex = ((int)(configurationAppSettings.GetValue("groupBox1.TabIndex", typeof(int))));
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = ((string)(configurationAppSettings.GetValue("groupBox1.Text", typeof(string))));
			this.groupBox1.Visible = ((bool)(configurationAppSettings.GetValue("groupBox1.Visible", typeof(bool))));
			// 
			// button17
			// 
			this.button17.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.button17.BackColor = System.Drawing.Color.Black;
			this.button17.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button17.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button17.ForeColor = System.Drawing.Color.Black;
			this.button17.Location = new System.Drawing.Point(8, 16);
			this.button17.Name = "button17";
			this.button17.Size = new System.Drawing.Size(56, 2);
			this.button17.TabIndex = 5;
			this.button17.Click += new System.EventHandler(this.button17_Click);
			// 
			// button5
			// 
			this.button5.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.button5.BackColor = System.Drawing.SystemColors.ControlText;
			this.button5.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button5.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button5.ForeColor = System.Drawing.Color.Black;
			this.button5.Location = new System.Drawing.Point(8, 96);
			this.button5.Name = "button5";
			this.button5.Size = new System.Drawing.Size(56, 8);
			this.button5.TabIndex = 4;
			this.button5.Click += new System.EventHandler(this.button5_Click);
			// 
			// button4
			// 
			this.button4.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.button4.BackColor = System.Drawing.SystemColors.ControlText;
			this.button4.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button4.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button4.ForeColor = System.Drawing.Color.Black;
			this.button4.Location = new System.Drawing.Point(8, 80);
			this.button4.Name = "button4";
			this.button4.Size = new System.Drawing.Size(56, 6);
			this.button4.TabIndex = 3;
			this.button4.Click += new System.EventHandler(this.button4_Click);
			// 
			// button3
			// 
			this.button3.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.button3.BackColor = System.Drawing.SystemColors.ControlText;
			this.button3.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button3.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button3.ForeColor = System.Drawing.Color.Black;
			this.button3.Location = new System.Drawing.Point(8, 64);
			this.button3.Name = "button3";
			this.button3.Size = new System.Drawing.Size(56, 5);
			this.button3.TabIndex = 2;
			this.button3.Click += new System.EventHandler(this.button3_Click);
			// 
			// button2
			// 
			this.button2.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.button2.BackColor = System.Drawing.SystemColors.ControlText;
			this.button2.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button2.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button2.ForeColor = System.Drawing.Color.Black;
			this.button2.Location = new System.Drawing.Point(8, 48);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(56, 4);
			this.button2.TabIndex = 1;
			this.button2.Click += new System.EventHandler(this.button2_Click);
			// 
			// button1
			// 
			this.button1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.button1.BackColor = System.Drawing.Color.Black;
			this.button1.Cursor = System.Windows.Forms.Cursors.Hand;
			this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
			this.button1.ForeColor = System.Drawing.Color.Black;
			this.button1.Location = new System.Drawing.Point(8, 32);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(56, 3);
			this.button1.TabIndex = 0;
			this.button1.Text = "button1";
			this.button1.Click += new System.EventHandler(this.button1_Click);
			// 
			// panel2
			// 
			this.panel2.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel2.AutoScroll = ((bool)(configurationAppSettings.GetValue("panel2.AutoScroll", typeof(bool))));
			this.panel2.BackColor = System.Drawing.SystemColors.ActiveCaptionText;
			this.panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel2.Cursor = System.Windows.Forms.Cursors.Cross;
			this.panel2.DockPadding.All = 2;
			this.panel2.Enabled = ((bool)(configurationAppSettings.GetValue("panel2.Enabled", typeof(bool))));
			this.panel2.Location = new System.Drawing.Point(96, 0);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(10048, 10136);
			this.panel2.TabIndex = 2;
			this.panel2.Visible = ((bool)(configurationAppSettings.GetValue("panel2.Visible", typeof(bool))));
			this.panel2.MouseUp += new System.Windows.Forms.MouseEventHandler(this.panel2_MouseUp);
			this.panel2.Paint += new System.Windows.Forms.PaintEventHandler(this.panel2_Paint);
			this.panel2.MouseMove += new System.Windows.Forms.MouseEventHandler(this.panel2_MouseMove);
			this.panel2.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panel2_MouseDown);
			// 
			// vScrollBar1
			// 
			this.vScrollBar1.AccessibleDescription = ((string)(configurationAppSettings.GetValue("vScrollBar1.AccessibleDescription", typeof(string))));
			this.vScrollBar1.AccessibleName = ((string)(configurationAppSettings.GetValue("vScrollBar1.AccessibleName", typeof(string))));
			this.vScrollBar1.AllowDrop = ((bool)(configurationAppSettings.GetValue("vScrollBar1.AllowDrop", typeof(bool))));
			this.vScrollBar1.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.vScrollBar1.CausesValidation = ((bool)(configurationAppSettings.GetValue("vScrollBar1.CausesValidation", typeof(bool))));
			this.vScrollBar1.Enabled = ((bool)(configurationAppSettings.GetValue("vScrollBar1.Enabled", typeof(bool))));
			this.vScrollBar1.LargeChange = ((int)(configurationAppSettings.GetValue("vScrollBar1.LargeChange", typeof(int))));
			this.vScrollBar1.Location = new System.Drawing.Point(0, 0);
			this.vScrollBar1.Maximum = ((int)(configurationAppSettings.GetValue("vScrollBar1.Maximum", typeof(int))));
			this.vScrollBar1.Minimum = ((int)(configurationAppSettings.GetValue("vScrollBar1.Minimum", typeof(int))));
			this.vScrollBar1.Name = "vScrollBar1";
			this.vScrollBar1.Size = new System.Drawing.Size(16, 536);
			this.vScrollBar1.SmallChange = ((int)(configurationAppSettings.GetValue("vScrollBar1.SmallChange", typeof(int))));
			this.vScrollBar1.TabIndex = ((int)(configurationAppSettings.GetValue("vScrollBar1.TabIndex", typeof(int))));
			this.vScrollBar1.TabStop = ((bool)(configurationAppSettings.GetValue("vScrollBar1.TabStop", typeof(bool))));
			this.vScrollBar1.Value = ((int)(configurationAppSettings.GetValue("vScrollBar1.Value", typeof(int))));
			this.vScrollBar1.Visible = ((bool)(configurationAppSettings.GetValue("vScrollBar1.Visible", typeof(bool))));
			this.vScrollBar1.Scroll += new System.Windows.Forms.ScrollEventHandler(this.vScrollBar1_Scroll);
			// 
			// hScrollBar1
			// 
			this.hScrollBar1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Left | System.Windows.Forms.AnchorStyles.Right)));
			this.hScrollBar1.LargeChange = 200;
			this.hScrollBar1.Location = new System.Drawing.Point(0, 0);
			this.hScrollBar1.Maximum = 9000;
			this.hScrollBar1.Name = "hScrollBar1";
			this.hScrollBar1.Size = new System.Drawing.Size(512, 16);
			this.hScrollBar1.SmallChange = 100;
			this.hScrollBar1.TabIndex = 0;
			this.hScrollBar1.Scroll += new System.Windows.Forms.ScrollEventHandler(this.hScrollBar1_Scroll);
			// 
			// statusBar1
			// 
			this.statusBar1.Enabled = ((bool)(configurationAppSettings.GetValue("statusBar1.Enabled", typeof(bool))));
			this.statusBar1.Location = new System.Drawing.Point(0, 553);
			this.statusBar1.Name = "statusBar1";
			this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						  this.statusBarPanel1});
			this.statusBar1.ShowPanels = ((bool)(configurationAppSettings.GetValue("statusBar1.ShowPanels", typeof(bool))));
			this.statusBar1.Size = new System.Drawing.Size(624, 24);
			this.statusBar1.SizingGrip = ((bool)(configurationAppSettings.GetValue("statusBar1.SizingGrip", typeof(bool))));
			this.statusBar1.TabIndex = ((int)(configurationAppSettings.GetValue("statusBar1.TabIndex", typeof(int))));
			this.statusBar1.TabStop = ((bool)(configurationAppSettings.GetValue("statusBar1.TabStop", typeof(bool))));
			this.statusBar1.Text = ((string)(configurationAppSettings.GetValue("statusBar1.Text", typeof(string))));
			this.statusBar1.Visible = ((bool)(configurationAppSettings.GetValue("statusBar1.Visible", typeof(bool))));
			// 
			// statusBarPanel1
			// 
			this.statusBarPanel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.statusBarPanel1.MinWidth = ((int)(configurationAppSettings.GetValue("statusBarPanel1.MinWidth", typeof(int))));
			this.statusBarPanel1.Text = ((string)(configurationAppSettings.GetValue("statusBarPanel1.Text", typeof(string))));
			this.statusBarPanel1.ToolTipText = ((string)(configurationAppSettings.GetValue("statusBarPanel1.ToolTipText", typeof(string))));
			this.statusBarPanel1.Width = ((int)(configurationAppSettings.GetValue("statusBarPanel1.Width", typeof(int))));
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.AddExtension = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.AddExtension", typeof(bool))));
			this.saveFileDialog1.CheckFileExists = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.CheckFileExists", typeof(bool))));
			this.saveFileDialog1.CheckPathExists = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.CheckPathExists", typeof(bool))));
			this.saveFileDialog1.CreatePrompt = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.CreatePrompt", typeof(bool))));
			this.saveFileDialog1.DefaultExt = ((string)(configurationAppSettings.GetValue("saveFileDialog1.DefaultExt", typeof(string))));
			this.saveFileDialog1.DereferenceLinks = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.DereferenceLinks", typeof(bool))));
			this.saveFileDialog1.FileName = ((string)(configurationAppSettings.GetValue("saveFileDialog1.FileName", typeof(string))));
			this.saveFileDialog1.Filter = ((string)(configurationAppSettings.GetValue("saveFileDialog1.Filter", typeof(string))));
			this.saveFileDialog1.FilterIndex = ((int)(configurationAppSettings.GetValue("saveFileDialog1.FilterIndex", typeof(int))));
			this.saveFileDialog1.InitialDirectory = ((string)(configurationAppSettings.GetValue("saveFileDialog1.InitialDirectory", typeof(string))));
			this.saveFileDialog1.OverwritePrompt = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.OverwritePrompt", typeof(bool))));
			this.saveFileDialog1.RestoreDirectory = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.RestoreDirectory", typeof(bool))));
			this.saveFileDialog1.ShowHelp = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.ShowHelp", typeof(bool))));
			this.saveFileDialog1.Title = ((string)(configurationAppSettings.GetValue("saveFileDialog1.Title", typeof(string))));
			this.saveFileDialog1.ValidateNames = ((bool)(configurationAppSettings.GetValue("saveFileDialog1.ValidateNames", typeof(bool))));
			this.saveFileDialog1.FileOk += new System.ComponentModel.CancelEventHandler(this.saveFileDialog1_FileOk);
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.AddExtension = ((bool)(configurationAppSettings.GetValue("openFileDialog1.AddExtension", typeof(bool))));
			this.openFileDialog1.CheckFileExists = ((bool)(configurationAppSettings.GetValue("openFileDialog1.CheckFileExists", typeof(bool))));
			this.openFileDialog1.CheckPathExists = ((bool)(configurationAppSettings.GetValue("openFileDialog1.CheckPathExists", typeof(bool))));
			this.openFileDialog1.DefaultExt = ((string)(configurationAppSettings.GetValue("openFileDialog1.DefaultExt", typeof(string))));
			this.openFileDialog1.DereferenceLinks = ((bool)(configurationAppSettings.GetValue("openFileDialog1.DereferenceLinks", typeof(bool))));
			this.openFileDialog1.FileName = ((string)(configurationAppSettings.GetValue("openFileDialog1.FileName", typeof(string))));
			this.openFileDialog1.Filter = ((string)(configurationAppSettings.GetValue("openFileDialog1.Filter", typeof(string))));
			this.openFileDialog1.FilterIndex = ((int)(configurationAppSettings.GetValue("openFileDialog1.FilterIndex", typeof(int))));
			this.openFileDialog1.InitialDirectory = ((string)(configurationAppSettings.GetValue("openFileDialog1.InitialDirectory", typeof(string))));
			this.openFileDialog1.Multiselect = ((bool)(configurationAppSettings.GetValue("openFileDialog1.Multiselect", typeof(bool))));
			this.openFileDialog1.ReadOnlyChecked = ((bool)(configurationAppSettings.GetValue("openFileDialog1.ReadOnlyChecked", typeof(bool))));
			this.openFileDialog1.RestoreDirectory = ((bool)(configurationAppSettings.GetValue("openFileDialog1.RestoreDirectory", typeof(bool))));
			this.openFileDialog1.ShowHelp = ((bool)(configurationAppSettings.GetValue("openFileDialog1.ShowHelp", typeof(bool))));
			this.openFileDialog1.ShowReadOnly = ((bool)(configurationAppSettings.GetValue("openFileDialog1.ShowReadOnly", typeof(bool))));
			this.openFileDialog1.Title = ((string)(configurationAppSettings.GetValue("openFileDialog1.Title", typeof(string))));
			this.openFileDialog1.ValidateNames = ((bool)(configurationAppSettings.GetValue("openFileDialog1.ValidateNames", typeof(bool))));
			this.openFileDialog1.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog1_FileOk);
			// 
			// panel4
			// 
			this.panel4.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel4.Controls.Add(this.vScrollBar1);
			this.panel4.Location = new System.Drawing.Point(608, 0);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(16, 554);
			this.panel4.TabIndex = 4;
			// 
			// panel5
			// 
			this.panel5.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.panel5.Controls.Add(this.hScrollBar1);
			this.panel5.Location = new System.Drawing.Point(96, 536);
			this.panel5.Name = "panel5";
			this.panel5.Size = new System.Drawing.Size(512, 18);
			this.panel5.TabIndex = 5;
			// 
			// panel6
			// 
			this.panel6.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left)));
			this.panel6.BackColor = System.Drawing.SystemColors.ActiveBorder;
			this.panel6.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel6.Controls.Add(this.button18);
			this.panel6.Controls.Add(this.groupBox1);
			this.panel6.Controls.Add(this.panel3);
			this.panel6.Controls.Add(this.groupBox2);
			this.panel6.Controls.Add(this.button15);
			this.panel6.Controls.Add(this.button14);
			this.panel6.Controls.Add(this.button16);
			this.panel6.Location = new System.Drawing.Point(0, 0);
			this.panel6.Name = "panel6";
			this.panel6.Size = new System.Drawing.Size(96, 560);
			this.panel6.TabIndex = 2;
			// 
			// button18
			// 
			this.button18.Location = new System.Drawing.Point(8, 392);
			this.button18.Name = "button18";
			this.button18.TabIndex = 6;
			this.button18.Text = "Start_Stop";
			this.button18.Click += new System.EventHandler(this.button18_Click);
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(624, 577);
			this.Controls.Add(this.panel4);
			this.Controls.Add(this.panel5);
			this.Controls.Add(this.statusBar1);
			this.Controls.Add(this.panel6);
			this.Controls.Add(this.panel2);
			this.Cursor = System.Windows.Forms.Cursors.Arrow;
			this.HelpButton = true;
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Symmetry ";
			this.groupBox2.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.statusBarPanel1)).EndInit();
			this.panel4.ResumeLayout(false);
			this.panel5.ResumeLayout(false);
			this.panel6.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			
	//		Thread narisiObjekte1Thread = new Thread(new ThreadStart(Narisi_objekte1));
	//		Thread simSileThread = new Thread(new ThreadStart(simulirajSile));
	//		simSileThread.Start();
			Application.Run(new Form1());
			simSileThread.Abort();

		}
		
	
		


		//PANEL KJER SE RISE 
		private void panel2_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{	//ta funkcija se poklice vsakic ko je treba panle refresh-at
			
			
			
			//	AutoResetEvent autoEvent     = new AutoResetEvent(false);

				
		
			if(g == null)		
			{
				g = panel2.CreateGraphics();
				p = new Pen(Color.FromName(color));
				p.Width = pen_width;
				buttonEraser = false;
				p.EndCap = System.Drawing.Drawing2D.LineCap.Round;
				p.LineJoin = LineJoin.Round;
				hpt = new HiPerfTimer();
				this.WhichButton(1);
						
			}
			

			if(!simSileThread.IsAlive)
			{
				g.Clear(Color.White);
				//	this.Narisi_objekte(allStrokes);
				Narisi_objekte1(resitveStroki);
			}
			
			
		}



		
	
		/*-----------------------AKCIJE ZA MIKO-----------------------------------------------------------*/
		/*-------------------------------------------------------------------------------------------------*/
		private void panel2_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
				

			Random r = new Random();
			ColorChanger ch = new ColorChanger();
			Point po = new Point(e.X,e.Y);
		

			if((lastPoint.Equals(Point.Empty))) 
				lastPoint = new Point(e.X,e.Y);

		
			stopSimSileThread();

				
			saturacija = r.NextDouble();
			svetlost = r.NextDouble();
			
			indexG = 0;
			indexD = 0;
	          
			lastPoint = po;
		

			zeNarisanObjekt= false;
			zeNarisanObjekt = this.blizinaTocke(po);
			clikMedTockami = false;
			clikMedTockami = this.klikMedTockami(po);

		


			if(e.Button == MouseButtons.Left && zeNarisanObjekt)
			{
				Stroke1 st1;
                
				st1 = resitveStroki.returnStrokeObject(stStroka[0]);
				enStroke.addPoint(st1.returnElement(rightMouseButtonDown[0]),0);
			
				if(!enStroke.sosednjiStroki.Contains(stStroka[0]))
					enStroke.sosednjiStroki.Add(stStroka[0]);

			

				for(int i =0;i < st1.sosednjiStroki.Count;i++)
					if(!enStroke.sosednjiStroki.Contains(st1.sosednjiStroki[i]))
						enStroke.sosednjiStroki.Add(st1.sosednjiStroki[i]);

				lastAddedPoint = st1.returnElement(rightMouseButtonDown[0]);
				lastPoint = lastAddedPoint;
				oneStroke.addPoint(st1.returnElement(rightMouseButtonDown[0]),0);
		
	
				this.statusBarPanel1.Text = " I am painting !";

			}
			else if(e.Button == MouseButtons.Right && vstaviText && clikMedTockami)
			{
				if(stringAliInk)
				{
					Stroke1 st1;
					st1 = resitveStroki.returnStrokeObject(cifraStroka);
					if(resitveStroki.numberOfStrokes() > 0)
					{
						//Point p1 =  new  Point(e.X,e.Y);
						Point p1,p2;
						p1 = st1.returnElement(desniKlik);
						p2 = st1.returnElement(desniKlik+1); 
						
						int x = 0,y = 0; 
					//	x = e.X	 - ((Point)ink.returnElement(0)).X;
					//	y = e.Y  - ((Point)ink.returnElement(0)).Y;

						x = ((p1.X+p2.X)/2) - ((Point)ink.returnElement(0)).X;
						y = ((p1.Y+p2.Y)/2) - ((Point)ink.returnElement(0)).Y;

						
						st1 = resitveStroki.returnStrokeObject(cifraStroka);
						for(int i = 0;i<ink.numberOfPoints();i++)
						{
							p1 = (Point)ink.returnElement(i);
							p1.Offset(x,y);
							ink.changePoint(p1,i);
					
						}
						
						st1.inkiPovezav.Add(ink);
					
					}
				}
				else
				{
				
					Stroke1 st1;
					if(resitveStroki.numberOfStrokes() > 0)
					{
					//	st1 = resitveStroki.returnStrokeObject(resitveStroki.numberOfStrokes()-1);
						st1 = resitveStroki.returnStrokeObject(cifraStroka);
					
					//	st1.imenPovezav.Add(text);
					//	st1.imenPovezav.Add(new Point(e.X,e.Y));
					
						Point p1,p2;
						p1 = st1.returnElement(desniKlik);
						p2 = st1.returnElement(desniKlik+1); 
						p1 = new Point((p1.X+p2.X)/2,(p1.Y+p2.Y)/2);
					
						
							if(!st1.imenPovezav.Contains(p1))
							{
								st1.imenPovezav.Add(text);
								st1.imenPovezav.Add(p1);
							}
							else
							{
								st1.imenPovezav.RemoveAt(st1.imenPovezav.IndexOf(p1)-1);
								st1.imenPovezav.Insert(st1.imenPovezav.IndexOf(p1),text);
							}
						

					}
				
				}
				vstaviText = false;
			}
			else if(e.Button == MouseButtons.Left)
			{
				lastAddedPoint = po;
				enStroke.addPoint(po,0);
				oneStroke.addPoint(po,0);
				this.statusBarPanel1.Text = " I am painting !";
			}
			
			mouseDown = true;
				
		
			hpt.Start(); 
			StartTicks= 0;// set to zero
			cumTime=0;

			/*
						p.Color = ch.svetlost(p.Color,0.1);
			
								if(barva <= 1.0 && barva >= -1.0)
								{
								//	p.Color = ch.saturacija(ch.colorize(barva),saturacija);
					*/				p.Color = Color.FromName(color);
			/*			//	p.Color = ch.saturacija(p.Color,saturacija);
							p.Color = ch.svetlost(p.Color,svetlost);
				
						//	p.Color = ch.svetlost(ch.colorize(barva),svetlost);
						//	p.Color = ch.colorize(barva);
						
						}
						else
							barva = -1.0;

	
				barva = barva + 0.1;
				*/	

		
					
		}


		


		private void panel2_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
				
			
			if((lastPoint.Equals(Point.Empty))) 
				lastPoint = new Point(e.X,e.Y);

			
							
			if((mouseDown == true)&& (e.Button == MouseButtons.Left))
			{
				Point pMousePos = new Point(e.X,e.Y);
				
					
					
				g.DrawLine(p,pMousePos,lastPoint);

	
				hpt.Stop();
				EndTicks =hpt.Duration;
				cumTime+=EndTicks; // add to cum time elapsed
			
				if(!buttonEraser)
					oneStroke.addPoint(pMousePos,cumTime);
						
				if((recog.addPoint(lastPoint,pMousePos,cumTime) == 1)&& 
					(recog.pointDistance(lastAddedPoint,pMousePos)> razdaljaMedOgli))//&& !ogelNajden && !buttonEraser)
				{
					
					st_tock = 0;
						
							
					
					lastAddedPoint =  pMousePos; //lastAddedPoint se uporablja za racunanje razdalje  zadnje dodane tocke 

						
					if(l.returnFirstPoint().Equals(Point.Empty))	// premica skozi zadnji dve dodani tocki za racunanje boljsega prileganja
					{
							
						l.addFirstPoint(lastPoint.X,lastPoint.Y);
						indexD = oneStroke.numberOfPoints()-1;

					}
					else if(l.returnLastPoint().Equals(Point.Empty))
					{
						l.addLastPoint(lastPoint.X,lastPoint.Y);
						indexG = oneStroke.numberOfPoints()-1;
					}
					else
					{
						indexD = indexG;
						indexG = oneStroke.numberOfPoints()-1;
						l.addFirstPoint(l.returnLastPoint());
						l.addLastPoint(lastPoint.X,lastPoint.Y);

					}

										


					ColorChanger ch = new ColorChanger();
					p.Color = Color.DarkOrange;
					g.DrawRectangle(p,lastPoint.X-4,lastPoint.Y-4,8,8);
					//	p.Color = ch.svetlost(Color.FromName(color),0.1);
					//	oneStroke.addPoint(lastPoint,cumTime);
					//	System.Console.WriteLine("cas : "+cumTime);
					/*	if(!l.returnFirstPoint().Equals(Point.Empty)&&
							!l.returnLastPoint().Equals(Point.Empty))
						{
								
								
							for(i = indexD;i < indexG;i++)
							{
									
								po = oneStroke.returnElement(i);
								if(l.distancToPoint(po) > 5)
								{
									l.addFirstPoint(po.X,po.Y);
										enStroke.addPoint(po,0);

								}
									
							}
					

						}*/
					p.Color = Color.FromName(color);
					enStroke.addPoint(lastPoint,0);
						
				}
				else if(recog.pointDistance(lastAddedPoint,pMousePos)> razdaljaMedOgli)	//racunanje oglov s pomojo hitrosti
				{
					double a = 0;
					Point po;
											
					a = recog.pointDistance(lastPoint,pMousePos);
					a = a/cumTime;
								

					if((int)a < Hitrost_recognizer) //hitrost mora biti manjsa od 200 da postavimo ogel
					{
							
							
						if(l.returnFirstPoint().Equals(Point.Empty))	// premica skozi zadnji dve dodani tocki za racunanje boljsega prileganja
						{
							
							l.addFirstPoint(pMousePos.X,pMousePos.Y);
							indexD = oneStroke.numberOfPoints()-1;

						}
						else if(l.returnLastPoint().Equals(Point.Empty))
						{
							l.addLastPoint(pMousePos.X,pMousePos.Y);
							indexG = oneStroke.numberOfPoints()-1;
						}
						else
						{
							indexD = indexG;
							indexG = oneStroke.numberOfPoints()-1;
							l.addFirstPoint(l.returnLastPoint());
							l.addLastPoint(pMousePos.X,pMousePos.Y);

						}

						

						if(!l.returnFirstPoint().Equals(Point.Empty)&&
							!l.returnLastPoint().Equals(Point.Empty))
						{
								
								
							for(int i = indexD;i < indexG;i++)
							{
									
								po = oneStroke.returnElement(i);
								if(l.distancToPoint(po) > 5)
								{
									l.addFirstPoint(po.X,po.Y);
									enStroke.addPoint(po,0);

								}
							}
						}
							
						
						enStroke.addPoint(pMousePos,0);
						lastAddedPoint = pMousePos;
						g.DrawRectangle(p,pMousePos.X-4,pMousePos.Y-4,8,8);
							
							
					}

					
							
			
				}
					

										
				
				//this.statusBarPanel1.Text = cumTime.ToString();

				hpt.Start(); 
				StartTicks= 0;// set to zero
				cumTime=0;
				st_tock ++;
			}
			else if((mouseDown == true)&&(e.Button == MouseButtons.Right)&&(rightMouseButtonDown[0]!=-1)&&zeNarisanObjekt)//premikanje tock narisanega objekta
			{

					
				Point pMousePos = new Point(e.X,e.Y);
				Stroke1 st;
				int j = 0; 
			
			
						
							
		
				for(j = 0; j<100&&rightMouseButtonDown[j]!=-1;j++)
					if(rightMouseButtonDown[j]!=-1)
					{
						st = resitveStroki.returnStrokeObject(stStroka[j]);
							
						if((rightMouseButtonDown[j] == 0) && (st.numberOfPoints() > 1))
						{
							p.Color = Color.White;
							g.DrawLine(p,st.returnElement(0),st.returnElement(1));
							
							g.DrawEllipse(p,st.returnElement(0).X-razdaljaMedStikalisciTock/2,
								st.returnElement(0).Y-razdaljaMedStikalisciTock/2,razdaljaMedStikalisciTock,razdaljaMedStikalisciTock);
						

						}
						else if((rightMouseButtonDown[j] == (st.numberOfPoints()-1))&& 
							(st.numberOfPoints() > 1))
						{
							p.Color = Color.White;
							g.DrawLine(p,st.returnElement(st.numberOfPoints()-2),
								st.returnElement(st.numberOfPoints()-1));
							
							g.DrawEllipse(p,st.returnElement(st.numberOfPoints()-1).X-razdaljaMedStikalisciTock/2,
								st.returnElement(st.numberOfPoints()-1).Y-razdaljaMedStikalisciTock/2,razdaljaMedStikalisciTock,razdaljaMedStikalisciTock);
							

						}
						else 
						{
							p.Color = Color.White;
							g.DrawLine(p,st.returnElement(rightMouseButtonDown[j]),
								st.returnElement(rightMouseButtonDown[j]-1));
							g.DrawLine(p,st.returnElement(rightMouseButtonDown[j]),
								st.returnElement(rightMouseButtonDown[j]+1));
						
							g.DrawEllipse(p,st.returnElement(rightMouseButtonDown[j]).X-razdaljaMedStikalisciTock/2,
								st.returnElement(rightMouseButtonDown[j]).Y-razdaljaMedStikalisciTock/2,razdaljaMedStikalisciTock,razdaljaMedStikalisciTock);
					
						}

						st.changePoint(pMousePos,rightMouseButtonDown[j]);
						st.changePointForce(pMousePos,rightMouseButtonDown[j]);
					
					

						if((rightMouseButtonDown[j] == 0) && (st.numberOfPoints() > 1))
						{
						
							p.Color = Color.Gold;
							g.DrawLine(p,st.returnElement(0),st.returnElement(1));
						
						}
						else if((rightMouseButtonDown[j] == (st.numberOfPoints()-1))&&
							(st.numberOfPoints() > 1))
						{
							p.Color = Color.Gold;
							g.DrawLine(p,st.returnElement(st.numberOfPoints()-2),
								st.returnElement(st.numberOfPoints()-1));
					
					
						}
						else 
						{
							p.Color = Color.Gold;
							g.DrawLine(p,st.returnElement(rightMouseButtonDown[j]),
								st.returnElement(rightMouseButtonDown[j]-1));
							g.DrawLine(p,st.returnElement(rightMouseButtonDown[j]),
								st.returnElement(rightMouseButtonDown[j]+1));
						
						
						}
						
					
						
							
					}
				
				p.Color = Color.Black;
				for(int j1 = 0;j1 < resitveStroki.numberOfStrokes();j1++)
				{
					st = resitveStroki.returnStrokeObject(j1);
					for(int i1 = 0;i1<st.numberOfPoints();i1++)
					{
						g.DrawEllipse(p,st.returnElement(i1).X-razdaljaMedStikalisciTock/2,
							st.returnElement(i1).Y-razdaljaMedStikalisciTock/2,razdaljaMedStikalisciTock,razdaljaMedStikalisciTock);
					}
												
				}

				
							
			
				p.Color = Color.FromName(color);
		    		
		
			}
			else if((mouseDown == true)&&(e.Button == MouseButtons.Right)&&(desniKlik!=-1)&&clikMedTockami)//premikanje celotnega stroka
			{

				Point trenutna = new Point(e.X,e.Y);
				int x = 0 ,y = 0;
                
				Stroke1 st1;
				x = trenutna.X - lastPoint.X;
				y = trenutna.Y- lastPoint.Y;
                
				st1 = resitveStroki.returnStrokeObject(this.cifraStroka);
				for(int i = 0;i<st1.numberOfPoints();i++)
				{
					trenutna = st1.returnElement(i);
					trenutna.Offset(x,y);
					st1.changePoint(trenutna,i);
				}

			
				for(int i = 0;i<st1.inkiPovezav.Count;i++)
				{
					Stroke1 inki;
					inki = (Stroke1)st1.inkiPovezav[i];
					for(int j = 0; j < inki.numberOfPoints();j++)
					{
						trenutna = inki.returnElement(j);
						trenutna.Offset(x,y);
						inki.changePoint(trenutna,j);
					}
				}

				for(int i = 0;i <st1.vzporednePovezave.Count;i++)
				{
						trenutna = (Point)st1.vzporednePovezave[i];
						trenutna.Offset(x,y);
						st1.vzporednePovezave.RemoveAt(i);
						st1.vzporednePovezave.Insert(i,trenutna);
					
				}


				for(int i = 1;i<st1.imenPovezav.Count;i = i + 2)
				{
						trenutna = (Point)st1.imenPovezav[i];
						trenutna.Offset(x,y);
						st1.imenPovezav.RemoveAt(i);
						st1.imenPovezav.Insert(i,trenutna);
					
				}

			
				Stroke1 sosedi;
				for(int i = 0;i<st1.sosednjiStroki.Count;i++)
				{
				
					sosedi = resitveStroki.returnStrokeObject((int)st1.sosednjiStroki[i]);
					for(int j = 0;j<sosedi.numberOfPoints();j++)
					{
						trenutna = sosedi.returnElement(j);
						trenutna.Offset(x,y);
						sosedi.changePoint(trenutna,j);
					}

					for(int j = 0;j<sosedi.inkiPovezav.Count;j++)
					{
						Stroke1 inki;
						inki = (Stroke1)sosedi.inkiPovezav[j];
						for(int k = 0; k < inki.numberOfPoints();k++)
						{
							trenutna = inki.returnElement(k);
							trenutna.Offset(x,y);
							inki.changePoint(trenutna,k);
						}
					}

					for(int j = 0;j <sosedi.vzporednePovezave.Count;j++)
					{
						trenutna = (Point)sosedi.vzporednePovezave[j];
						trenutna.Offset(x,y);
						sosedi.vzporednePovezave.RemoveAt(j);
						sosedi.vzporednePovezave.Insert(j,trenutna);
					
					}


					for(int j = 1;j<sosedi.imenPovezav.Count;j = j + 2)
					{
						trenutna = (Point)sosedi.imenPovezav[j];
						trenutna.Offset(x,y);
						sosedi.imenPovezav.RemoveAt(j);
						sosedi.imenPovezav.Insert(j,trenutna);
					
					}

				
				}
				

					
			}
				
			lastPoint = new Point(e.X,e.Y);

				
		}

		/*-------------------------------------------------------------------------------------------------------*/
		private void panel2_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{	
			
			if(e.Button == MouseButtons.Left)
			{
		
				
				if(enStroke.numberOfPoints()>=1)
				{	Point point1 = new Point(e.X,e.Y);
					
					if(this.blizinaTocke(point1))
					{

						Stroke1 st1 = null;
						st1 = resitveStroki.returnStrokeObject(stStroka[0]);

						enStroke.addPoint(st1.returnElement(rightMouseButtonDown[0]),0);
					
						if(!enStroke.sosednjiStroki.Contains(stStroka[0]))
							enStroke.sosednjiStroki.Add(stStroka[0]);

						
						
						for(int i =0;i < st1.sosednjiStroki.Count;i++)
							if(!enStroke.sosednjiStroki.Contains(st1.sosednjiStroki[i]))
								enStroke.sosednjiStroki.Add(st1.sosednjiStroki[i]);
						
					}
					else
					{
						Point p4;
						p4 = enStroke.returnElement(enStroke.numberOfPoints()-1);
						if(!lastPoint.Equals(p4) &&
							(Math.Abs(lastPoint.X-p4.X)+Math.Abs(lastPoint.Y-p4.Y))>= 5)
							enStroke.addPoint(lastPoint,0);
					}

				}
			
				if(!buttonEraser && (mouseDown == true)&&(enStroke.numberOfPoints()> 1))
				{
				
					

					Point p4;
					p4 = enStroke.returnElement(0);
					if((Math.Abs(lastPoint.X-p4.X)+Math.Abs(lastPoint.Y-p4.Y))<= 20)//ce sta prva in zadnja tocka dovolj blizu je to sklenjen objekt
					{
				
						enStroke.spremeniVrstoObjekta(true);
						enStroke.removePoint(enStroke.numberOfPoints()-1);
						enStroke.addPoint(enStroke.returnElement(0),0);
				
					}
					

					enStroke.addWidth(pen_width);
					enStroke.addColor(p.Color);
				
					if(enStroke.numberOfPoints()> 2)	//pogledamo se za zadnjo tocko
					{
						indexD = indexG;
						indexG = oneStroke.numberOfPoints()-1;
						l.addFirstPoint(l.returnLastPoint());
						if(enStroke.vrniVrsto())
							l.addLastPoint(p4);
						else
							l.addLastPoint(enStroke.returnElement(enStroke.numberOfPoints()-1));
					}
					else
					{
						indexD = 0;
						indexG = 0;

					}
				
					recog = new Recognizer2();
					enStroke = recog.aliJeKrivulja(enStroke,oneStroke,g);

			

					if(!krivulja)
					for(int i = 1;i<enStroke.numberOfPoints()-2;i++)	//odstranimo odvecne tocke iz seznama tock,ki sestavljajo objekt
					{
						double a = 0,b = 0,c = 0,angle = 0;
						Point p1,p2,p3;

						p1 =  enStroke.returnElement(i);
						p2 =  enStroke.returnElement(i+1);
						p3 =  enStroke.returnElement(i+2);
						a = recog.pointDistance(p1,p2);
						b = recog.pointDistance(p3,p2);
						c = recog.pointDistance(p1,p3);
						angle = recog.calcAngle(p1,p2,p3);
						
						if((angle > 150)&&(angle <= 180))
						{
							enStroke.removePoint(i+1);
							i--;
						}
					

					}

		
					

				
				

					oneStroke.addWidth(pen_width);
					oneStroke.addColor(p.Color);

					if((oneStroke.numberOfPoints())>1)
						allStrokes.addStroke(oneStroke);
				
					ColorChanger  ch = new ColorChanger();
				

				//	rr.getAngle(oneStroke,3);
				

					
					//olepsevanje narisanih objektov
					PointManipulation poman = new PointManipulation();
					if(!krivulja)
					{
					//      poman.roundAngle(enStroke,20);
						poman.popraviSkorajOgle(enStroke,g,p);
					}
					
					rr.getAngle(enStroke,1);
					

					if(narisiMrezo)
					{
						poman.roundDistance(enStroke,5);
						poman.alignToGrid(enStroke,sirinaVisinaMreze);
					}
				
			
				
			
					
					//klasificiranje objekta tock
					if(!krivulja)
					if(cos.klasificirajObjekt(enStroke,p,g) == 0)
					{
					
			
						enStroke.addColor(Color.FromName(color));
						enStroke.addWidth(pen_width);
				
					}
		
					
					
					if((enStroke.numberOfPoints())>1)
					{
						
						
						recog.aliNarsiemOdvisnost = this.menuItem27.Checked;
						

						if(enStroke.sosednjiStroki.Count == 0 && !krivulja)
							enStroke = recog.zaokroziKote(enStroke,g);
						else if(!krivulja)
							enStroke = recog.zaokroziKoteGledeNaSosede(enStroke,resitveStroki,g);


						this.dodajSile();
						resitveStroki.addStroke(enStroke);

						if(enStroke.sosednjiStroki.Count > 0)
						{
							Stroke1 st1,strr;
							st1 = resitveStroki.returnStrokeObject((int)enStroke.sosednjiStroki[0]);
							if(!st1.sosednjiStroki.Contains(resitveStroki.numberOfStrokes()-1))
								st1.sosednjiStroki.Add(resitveStroki.numberOfStrokes()-1);
							
							for(int i = 0;i<enStroke.sosednjiStroki.Count;i++)
							{
								strr = resitveStroki.returnStrokeObject((int)enStroke.sosednjiStroki[i]);
								if(!strr.sosednjiStroki.Contains(resitveStroki.numberOfStrokes()-1))
									strr.sosednjiStroki.Add(resitveStroki.numberOfStrokes()-1);
								
							}
						}
					}
						
					
					

				
					//	allStrokes.addStroke(enStroke);

		
					/*		pt1 = rr.addRecog(oneStroke);
							p.Color = Color.DeepSkyBlue;
							p.Width = 1;
							for(int i = 0;i<oneStroke.numberOfPoints();i++) 
							{
								//System.Console.WriteLine(oneStroke.returnRecognitionAngle(i).ToString());
								if(oneStroke.returnRecognitionAngle(i) > 30 && 	oneStroke.returnRecognitionAngle(i)< 150 )
								{
						
									pt1 = oneStroke.returnElement(i);
										g.DrawRectangle(p,pt1.X-10,pt1.Y-10,20,20);
								}
					
							}
					*/		
			

				
					oneStroke = new Stroke1();
					enStroke = new Stroke1();
					indexD = 0;
					indexG = 0;
					//	p.Color = Color.FromName(color);
					//	p.Color = ch.colorize(r.NextDouble());
					//	p.Color = ch.svetlost(p.Color,r.NextDouble());
					//	p.Color = ch.saturacija(p.Color,r.NextDouble());
					p.Width = pen_width;
			
					hpt.Stop(); 
				
				}
            
      	
				this.statusBarPanel1.Text = "Symmetry rules !";
				mouseDown = false; 
				zeNarisanObjekt= false;
				krivulja = false;

				
				
			}
			
				
			

			g.Clear(Color.White);
	//		this.Narisi_objekte(allStrokes);
			Narisi_objekte1(resitveStroki);
			
		

			for(int i = 0;i<100;i++)
			{
				rightMouseButtonDown[i] = -1;
				stStroka[i] = -1;
			}

			
			
		}

		/*-------------------------------------------------------------------------------------------------------------*/
		private void dodajSile()
		{
		
			//----------------------------------------------------------------------------------
			//dodajanje sil posameznim tockam
			ForceItem forI = new ForceItem();
			ForceSimulator fSim = enStroke.returnForceSimulator();
			GravitationalForce gforce = new GravitationalForce(gKonstanta,smerGravSile);
			CircularWallForce crW;
			DragForce dF = new DragForce(100);
		//	Random r = new Random(0);
			int i = 0;


			for(i = 0;i<enStroke.numberOfPoints();i++)
			{
				ForceItem forItem = new ForceItem();
				
				forItem.location[0] = (float)(enStroke.returnElement(i)).X;
				forItem.location[1] = (float)(enStroke.returnElement(i)).Y;
			
				forItem.velocity[0] = 0f;//(float)r.NextDouble();
				forItem.velocity[1] = 0f;//(float)r.NextDouble();
			
			
				
					if(i%2 ==  0)
					//if((enStroke.returnRecognitionAngle(i) < 110) || (i == 0) || (i == (enStroke.numberOfPoints()-1)))
					{
					
						crW = new CircularWallForce(silaCirculalWall,(float)(enStroke.returnElement(i)).X,(float)(enStroke.returnElement(i)).Y,radijCirculalWall);
						enStroke.addForce(crW);
						forItem.force[0] = 0f;
						forItem.force[1] = 0f;
						forItem.mass = 10f;
				
					}
					else
					{
						forItem.mass = 100f;
						forItem.force[0] =  0;//(float)r.NextDouble();
						forItem.force[1] = 0;//(float)r.NextDouble();
				
					}
			
					enStroke.addForceItem(forItem);
		

			}


		

			
				
		//	enStroke.addForce(gforce);
		//	enStroke.addForce(crW);
		//	crW = new CircularWallForce(-15f,100f,100f,2000f);
		//	enStroke.addForce(crW);
	//		enStroke.addForce(dF);
			enStroke.addSpeedlimit(omejitevHitrosti);

		
		}
/*---------------------------------------------------------------------------------------------------------------*/
		//funkcija kjer simuliramo sile na posamezne tocek


		private static void simulirajSile()//(Strokes1 allSt)
		{

			int i,num_strokes = 0;
			Stroke1 st;
		
			while(true)
			{
			    num_strokes = resitveStroki.numberOfStrokes();
				for(i = 0;i < num_strokes;i++)
				{
					st = (Stroke1)resitveStroki.returnStrokeObject(i);
					st.runForceSimulator(casovniKorak,pen_width,g);		//parameter je hitrost simulacije
				    
				}
			
				Narisi_objekte1(resitveStroki);

			}
	
		}

/*-------------------------------------------------------------------------------------------------------------*/

		private bool blizinaTocke(Point po)			//pogledamo ce smo kje zraven tocke kliknili
		{
			
			Stroke1 st;
			Point p1;
			int i = 0;
			int j = 0;
			int index1 = 0;
				

			for(i = 0;i<100;i++)
			{
				rightMouseButtonDown[i] = -1;
				stStroka[i] = -1;
			}
					
		
		
			for(i = 0;i<resitveStroki.numberOfStrokes();i++)
			{		
				st = resitveStroki.returnStrokeObject(i);
				if(st.numberOfPoints()!=0)
					for(j = 0;j<st.numberOfPoints();j++)
					{
						p1 = st.returnElement(j);

						int razdalja = 0;
						razdalja = (int)Math.Sqrt(Math.Pow(p1.X-po.X,2)+Math.Pow(p1.Y-po.Y,2));

						if(razdalja<=razdaljaMedStikalisciTock/2)
						{
							
							if(j+1 < st.numberOfPoints() &&  st.numberOfPoints()> 2)
								if(p1.Equals(st.returnElement(j+1)))
								{
									st.removePoint(j+1);
									st.removeForceItem(j+1);
														
								}

							rightMouseButtonDown[index1] = j;
							stStroka[index1] = i;
							index1++;
								
							
							
						}
							
					}
		

						
			}

		
			if(rightMouseButtonDown[0]!=-1)
				return true;
			else
				return false;
		
		}
	
/*-------------------------------------------------------------------------------------------------------------*/

		private bool klikMedTockami(Point po)			//pogledamo ce smo kje zraven tocke kliknili
		{
			
			Stroke1 st;
			Point p1,p2;
			int i = 0;
			int j = 0;
			
			
			desniKlik = -1;
			cifraStroka = -1;
			
					
		
		
			for(i = 0;i<resitveStroki.numberOfStrokes();i++)
			{		
				st = resitveStroki.returnStrokeObject(i);
				if(st.numberOfPoints()!=0)
					for(j = 0;j<st.numberOfPoints()-1;j++)
					{
						p1 = st.returnElement(j);
						p2 = st.returnElement(j+1);

						int razdalja = 0;
						int maxX = 0,maxY = 0,minX = 0,minY = 0;

						razdalja = (int)(Math.Abs((p2.X-p1.X)*(p1.Y-po.Y)-(p1.X-po.X)*(p2.Y-p1.Y))/
							Math.Sqrt(Math.Pow(p2.X-p1.X,2)+Math.Pow(p2.Y-p1.Y,2)));
						
						maxX = Math.Max(p1.X,p2.X);
						minX = Math.Min(p1.X,p2.X);
						maxY = Math.Max(p1.Y,p2.Y);
						minY = Math.Min(p1.Y,p2.Y);

						maxX = maxX +razdaljaMedStikalisciTock/2;
						minX = minX -razdaljaMedStikalisciTock/2;
						maxY = maxY +razdaljaMedStikalisciTock/2;
						minY = minY -razdaljaMedStikalisciTock/2;

						if((razdalja <= razdaljaMedStikalisciTock/2) &&
							(( po.X <= maxX && po.X >= minX)&&(po.Y <= maxY && po.Y >= minY)))
						{
							
							
							desniKlik = j;
							cifraStroka = i;
							break;
							
						}
							
					}
				
				if(desniKlik!=-1)
					break;
		
				
						
			}
				
			if(desniKlik!=-1)
				return true;
			else
				return false;
		
		}
		/*--------------GUMBI ZA SPREMINJANJE BARVE---------------------------------------------------------*/		
		/*-----------------------SPREMINJANJE VELIKOSTI RNILA----------------------------------------------*/		
		private void button17_Click(object sender, System.EventArgs e)
		{
		
			pen_width = 1;
			p.Width = pen_width;
			if(buttonEraser)				//e smo imeli sluajno vklopljeno radirko moramo spremeniti barvo
			{
				buttonEraser = false;
				p.Color = Color.FromName(color);
				this.panel2.Cursor = Cursors.Cross;
			}
			this.WhichButton(1);
		
		}
		
		
		
		private void button1_Click(object sender, System.EventArgs e)
		{
			pen_width = 2;
			p.Width = pen_width;
			if(buttonEraser)				//e smo imeli sluajno vklopljeno radirko moramo spremeniti barvo
			{
				buttonEraser = false;
				p.Color = Color.FromName(color);	
				this.panel2.Cursor = Cursors.Cross;
			}
			this.WhichButton(2);
			
		}
		private void button2_Click(object sender, System.EventArgs e)
		{
			pen_width = 3;
			p.Width = pen_width;
			if(buttonEraser)
			{
				buttonEraser = false;
				p.Color = Color.FromName(color);
				this.panel2.Cursor = Cursors.Cross;
			}
			this.WhichButton(3);
		
		}

		private void button3_Click(object sender, System.EventArgs e)
		{
			pen_width = 4;
			p.Width = pen_width;
			if(buttonEraser)
			{
				buttonEraser = false;
				p.Color = Color.FromName(color);
				this.panel2.Cursor = Cursors.Cross;
			}
			this.WhichButton(4);
		}

		private void button4_Click(object sender, System.EventArgs e)
		{
			pen_width = 5;
			p.Width = pen_width;
			if(buttonEraser)
			{
				buttonEraser = false;
				p.Color = Color.FromName(color);
				this.panel2.Cursor = Cursors.Cross;
			}
			this.WhichButton(5);
		}

		private void button5_Click(object sender, System.EventArgs e)
		{
			pen_width = 7;
			p.Width = pen_width;
			if(buttonEraser)
			{
				buttonEraser = false;
				p.Color = Color.FromName(color);
				this.panel2.Cursor = Cursors.Cross;
			}
			this.WhichButton(6);
		}

		//spremenimo ozadje gumbov, da se vidi kateri je bil pritisnjen
		private void WhichButton(int buttonNumber)
		{
				

			switch(buttonNumber)
			{
				case 1: button17.BackColor = Color.FromName("White");
					button17.ForeColor = Color.FromName("White");
					break;
				case 2: button1.BackColor = Color.FromName("White");
					button1.ForeColor = Color.FromName("White");
					break;
				case 3:	button2.BackColor = Color.FromName("White");
					button2.ForeColor = Color.FromName("White");
					break;
				case 4:	button3.BackColor = Color.FromName("White");
					button3.ForeColor = Color.FromName("White");
					break;
				case 5:	button4.BackColor = Color.FromName("White");
					button4.ForeColor = Color.FromName("White");
					break;
				case 6:	button5.BackColor = Color.FromName("White");
					button5.ForeColor = Color.FromName("White");
					break;
				default :
					this.statusBar1.Text = "Ne najdem Gumba ->WhichButton";
					break;
			}
			//popravimo Background gumbov, ki jih nismo pritisnili
			if(buttonNumber != 1)		
			{			
				button17.BackColor = Color.FromName("Black");
				button17.ForeColor = Color.FromName("Black");
			}
			if(buttonNumber != 2)
			{
				button1.BackColor = Color.FromName("Black");
				button1.ForeColor = Color.FromName("Black");
			}
			if(buttonNumber != 3)
			{
				button2.BackColor = Color.FromName("Black");
				button2.ForeColor = Color.FromName("Black");
			}
			if(buttonNumber != 4)
			{
				button3.BackColor = Color.FromName("Black");
				button3.ForeColor = Color.FromName("Black");
			}
			if(buttonNumber != 5)
			{
				button4.BackColor = Color.FromName("Black");
				button4.ForeColor = Color.FromName("Black");
			}
			if(buttonNumber != 6)
			{
				button5.BackColor = Color.FromName("Black");
				button5.ForeColor = Color.FromName("Black");
			}

		}
		/*--------------GUMBI ZA SPREMINJANJE BARVE--------------------------------*/
		/*-----------------SPREMINJANJE BARVE-------------------------------------*/
		private void button8_Click(object sender, System.EventArgs e)
		{
			color = "Silver";	
			p.Color = Color.FromName(color);
			p.Width = pen_width;
			buttonEraser = false;
			panel3.BackColor = p.Color; //panel ki prikazuje barvo s katero risemo
			this.panel2.Cursor = Cursors.Cross;	
		}

		private void button12_Click(object sender, System.EventArgs e)
		{
			color = "Aqua";	
			p.Color = Color.FromName(color);
			p.Width = pen_width;
			buttonEraser = false;
			panel3.BackColor = p.Color;
			this.panel2.Cursor = Cursors.Cross;
		}

		private void button6_Click(object sender, System.EventArgs e)
		{
			color = "Black";	
			p.Color = Color.FromName(color);
			p.Width = pen_width;
			buttonEraser = false;
			panel3.BackColor = p.Color;
			this.panel2.Cursor = Cursors.Cross;
		}

		private void button11_Click(object sender, System.EventArgs e)
		{
			color = "Yellow";
			p.Color = Color.FromName(color);
			p.Width = pen_width;
			buttonEraser = false;
			panel3.BackColor = p.Color;
			this.panel2.Cursor = Cursors.Cross;
		}

		private void button10_Click(object sender, System.EventArgs e)
		{
			color = "Red";
			p.Color = Color.FromName(color);
			p.Width = pen_width;
			buttonEraser = false;
			panel3.BackColor = p.Color;
			this.panel2.Cursor = Cursors.Cross;
		}

		private void button13_Click(object sender, System.EventArgs e)
		{
			color = "Sienna";
			p.Color = Color.FromName(color);
			p.Width = pen_width;
			buttonEraser = false;
			panel3.BackColor = p.Color;
			this.panel2.Cursor = Cursors.Cross;
		}

		private void button7_Click(object sender, System.EventArgs e)
		{
			color = "LawnGreen";
			p.Color = Color.FromName(color);
			p.Width = pen_width;
			buttonEraser = false;
			panel3.BackColor = p.Color;
			this.panel2.Cursor = Cursors.Cross;
		}

		private void button9_Click(object sender, System.EventArgs e)		
		{
			
			color = "MediumBlue";
			p.Color = Color.FromName(color);
			p.Width = pen_width;
			buttonEraser = false;
			panel3.BackColor = p.Color;
			this.panel2.Cursor = Cursors.Cross;
					
		}

		
		/*-----------------------------DODATNI GUMBI-------------------------------------*/
		

		private void button14_Click(object sender, System.EventArgs e)		//gumb ->Clear
		{
			stopSimSileThread();
			allStrokes.clearStrokes();
			resitveStroki.clearStrokes();
			g.Clear(Color.FromName("White"));
			Narisi_objekte1(resitveStroki);
			
		}

		private void button15_Click(object sender, System.EventArgs e)	//gumb -> Eraser
		{	
			
			stopSimSileThread();

			color = "White";
			p.Color = Color.FromName(color);
			p.Width = 40;
			buttonEraser = true;
			this.panel2.Cursor = new Cursor("../../Cursor1.Cur"); 
		
		}
		/*----------------------------------------------------------------------------------------*/
		
		private void menuItem4_Click(object sender, System.EventArgs e)	//File->Exit
		{
			stopSimSileThread();

			allStrokes.clearStrokes();
			resitveStroki.clearStrokes();
			Application.Exit();
		}

		private void button16_Click(object sender, System.EventArgs e) //gumb Objects
		{
			int j = 0;
			Stroke1 st;
				
			g.Clear(Color.FromName("White"));
	
			if(objectNumber < allStrokes.numberOfStrokes())
			{	
				
				st = (Stroke1)allStrokes.returnStrokeObject(objectNumber);
				p.Color = st.returnColor();
				p.Width = st.returnWidth();
				for(j = 0;j < st.numberOfPoints()-1;j++)
					g.DrawLine(p,st.returnElement(j),st.returnElement(j+1));
				objectNumber++;
			}
			else 
				objectNumber = 0;
						

		}

		

		private void menuItem5_Click(object sender, System.EventArgs e)//File->New
		{
			stopSimSileThread();

			allStrokes.clearStrokes();
			resitveStroki.clearStrokes();
			this.panel2.Refresh();
		}

		private void menuItem6_Click(object sender, System.EventArgs e) //Edit->Undo
		{
			stopSimSileThread();

			if((allStrokes.numberOfStrokes())> 0)
			{
				
				allStrokes.clearLastStroke();		//dejansko pobriemo zadnji stroke
				resitveStroki.clearLastStroke();
				Stroke1 strr;
				int stevilo = resitveStroki.numberOfStrokes();

				for(int i = 0;i<resitveStroki.numberOfStrokes();i++)
				{
					strr = resitveStroki.returnStrokeObject(i);
					if(strr.sosednjiStroki.Contains(stevilo))
						strr.sosednjiStroki.Remove(stevilo);
				}
			
				panel2.Refresh();
				//	Narisi_objekte(allStrokes);
				Narisi_objekte1(resitveStroki);
		
				
			}
			else
				statusBarPanel1.Text = "NAPAKA : V bazi ni ve objektov!";
			
		}

			

		
		/*-------------------------------------------------------------------------------------------------------------*/
		private void menuItem13_Click_1(object sender, System.EventArgs e)	//File -> Save As
		{			
			stopSimSileThread();

			saveFileDialog1.ShowDialog();

		}

		private void saveFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)//File -Save As..
		{
			int i = 0;
			int j = 0;
			Point po;
			Stroke1 st = null;
			StreamWriter writer;
		
					
          
			writer = new StreamWriter(saveFileDialog1.FileName,true);
			/*
								
				if((allStrokes.numberOfStrokes())> 0)
				{
				
					for(j = 0;j < allStrokes.numberOfStrokes();j++)
					{	
						st = (Stroke1)allStrokes.returnStrokeObject(j);
							 for(i = 0;i < st.numberOfPoints();i++)
							 {
									  po = st.returnElement(i);
									  writer.Write(po.X.ToString()+","+po.Y.ToString()+";");
							//		  writer.Write(((int)(st.returnRecognitionAngle(i))).ToString()+";"); 
				
							  }
							 writer.Write("|");
							 writer.Write(st.returnColor().Name+",");
							 writer.Write(st.returnWidth().ToString()+";"); 
							 writer.Write(writer.NewLine);
					
					}
				}
				else
					this.statusBarPanel1.Text = "No objects to save !";	
			*/
			if((resitveStroki.numberOfStrokes())> 0)
			{
				
				for(j = 0;j < resitveStroki.numberOfStrokes();j++)
				{	
					st = (Stroke1)resitveStroki.returnStrokeObject(j);
					for(i = 0;i < st.numberOfPoints();i++)
					{
						po = st.returnElement(i);
						writer.Write(po.X.ToString()+","+po.Y.ToString()+";");
						//		  writer.Write(((int)(st.returnRecognitionAngle(i))).ToString()+";"); 
				
					}
					writer.Write("|");
					writer.Write(st.returnColor().Name+",");
					writer.Write(st.returnWidth().ToString()+";"); 
					writer.Write(writer.NewLine);
					
				}
			}
			else
				this.statusBarPanel1.Text = "No objects to save !";	
					
			writer.Close();	
			saveFileDialog1.Dispose();
		}
		/*-------------------------------------------------------------------------------------------------------*/
		private void Narisi_objekte(Strokes1 allSt)// nekaken refresh,ki ga lahko sami poklicemo 
		{

			int i,j,num_points = 0,num_strokes = 0;
			Stroke1 st;
			
			
	
			if(g == null)
			{
				g = panel2.CreateGraphics();
				p = new Pen(Color.FromName(color));
				p.EndCap = System.Drawing.Drawing2D.LineCap.Round;
				p.LineJoin = LineJoin.Round;
				p.Width = pen_width;
				buttonEraser = false;
				panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
				
			}

				

			num_strokes = allSt.numberOfStrokes();
			this.statusBarPanel1.Text = num_strokes.ToString();
			if(num_strokes > 0)
				for(i = 0;i < num_strokes;i++)
				{
					st = (Stroke1)allSt.returnStrokeObject(i);
					p.Color = st.returnColor();
					p.Width = st.returnWidth();
					num_points = st.numberOfPoints();
					num_points--;
					for(j = 0;j < num_points;j++)
					{
						
						g.DrawLine(p,st.returnElement(j),st.returnElement(j+1));
					}
				
				}
			p.Width = pen_width;
			p.Color = Color.FromName(color);
		
		}
		
		private static void Narisi_objekte1(Strokes1 allSt) // refresh za prepoznane objekte
		{

			int i,j,num_points = 0,num_strokes = 0;
			Stroke1 st;
			Pen pp = new Pen(Color.FromName(color));
					
			
	
			/*		if(g == null)
					{
						g = panel2.CreateGraphics();
						pp = new Pen(Color.FromName(color));
						pp.EndCap = System.Drawing.Drawing2D.LineCap.Round;
						pp.LineJoin = LineJoin.Round;
						pp.Width = pen_width;
						buttonEraser = false;
						panel2.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
						Controls.Add(panel2);
					}*/

				
			if(narisiMrezo)
			{
				pp.Width = 0.1f;
				pp.Color = Color.WhiteSmoke;
				PointManipulation poman1 = new PointManipulation();
				poman1.drawGrid(pp,g,100000,100000,sirinaVisinaMreze);
			}

			num_strokes = allSt.numberOfStrokes();
			//		this.statusBarPanel1.Text = num_strokes.ToString();
			if(num_strokes > 0)
				for(i = 0;i < num_strokes;i++)
				{
					st = (Stroke1)allSt.returnStrokeObject(i);
					pp.Color = st.returnColor();
					pp.Width = st.returnWidth();
					num_points = st.numberOfPoints();
					num_points--;
					for(j = 0;j < num_points;j++)
					{
						pp.Color = Color.Gold;
						pp.Width = st.returnWidth();
					    //Console.WriteLine("Koordinate: ({0},{1})",st.returnElement(j).X, st.returnElement(j).Y);
					
						//g.DrawRectangle(p,st.returnElement(j).X-10,st.returnElement(j).Y-10,20,20);
						g.DrawEllipse(pp,st.returnElement(j).X-razdaljaMedStikalisciTock/2,st.returnElement(j).Y-razdaljaMedStikalisciTock/2,razdaljaMedStikalisciTock,razdaljaMedStikalisciTock);
						pp.Color = st.returnColor();
						g.DrawLine(pp,st.returnElement(j),st.returnElement(j+1));
					}
					

                   // Console.WriteLine("");
					pp.Color = Color.Gold;
					pp.Width = st.returnWidth();
					//	g.DrawRectangle(p,st.returnElement(j).X-10,st.returnElement(j).Y-10,20,20);
					g.DrawEllipse(pp,st.returnElement(j).X-razdaljaMedStikalisciTock/2,st.returnElement(j).Y-razdaljaMedStikalisciTock/2,razdaljaMedStikalisciTock,razdaljaMedStikalisciTock);
				
					pp.Color = st.returnColor();
					for(j = 0;j < st.imenPovezav.Count;j = j + 2)
					{			
						Point point;
						point = (Point)st.imenPovezav[j+1];
						point.Offset(-((String)st.imenPovezav[j]).Length*3,0);
						g.DrawString((String)st.imenPovezav[j],new Font("Arial",9),pp.Brush,point);
						
					}
					

					for(j = 0;j < st.inkiPovezav.Count;j++)
					{		
						Stroke1 stro;
						stro = (Stroke1)st.inkiPovezav[j];
						for(int k = 0;k<stro.numberOfPoints()-1;k++)
						g.DrawLine(pp,stro.returnElement(k),stro.returnElement(k+1));

					}
					//g.DrawString(st.inkiPovezav.Count.ToString(),new Font("Arial",14),pp.Brush,new Point(10,10));
					
				
					int counter = 1;
					for(j = 0;j < st.vzporednePovezave.Count-1;j = j+2)
					{		
						pp.Color = Color.Blue;
						pp.Width = 1;
						pp.EndCap = System.Drawing.Drawing2D.LineCap.Triangle;
						Point p1,p2;
						p1 = (Point)st.vzporednePovezave[j];
						p2 = (Point)st.vzporednePovezave[j+1];
					
						g.DrawLine(pp,p1,p2);
						g.DrawString(counter.ToString(),new Font("Arial",14),pp.Brush,p2);
						counter++;

					}
			
				}
			
			
		
			
		
		}


		/*---------------------------------------------------------------------------------------------------------------*/	
		private void menuItem14_Click(object sender, System.EventArgs e)		//File-> Open
		{
			stopSimSileThread();

			openFileDialog1.ShowDialog();
		}

		private void openFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)//File -> Open
		{
			
			string  str1;
			Point po;
			StreamReader reader = null;
			Stroke1 oneSt;
		
			
						
			
			const char vejica = ',';
			const char podpicje = ';';
					
			
			char[] delemeter1 = new char[]
			{
				podpicje,
			};

			char[] delemeter2 = new char[]
			{
				vejica
			};

			

						
			reader = new StreamReader(openFileDialog1.FileName,true);
					
			
			int[] i = new int[3];
			int j;
			
			
			str1 = reader.ReadLine();
	
			do
			{ 
				if(str1 != null)
				{
					oneSt = new Stroke1();
					foreach(string Substring in str1.Split(delemeter1))
					{	
						
						if(!Substring.StartsWith("|"))
						{
							i[0] = 0;
							i[1] = 0;
							//		i[2] = 0;
							j = 0; 
							foreach(string Subs in Substring.Split(delemeter2))
							{
								if(j < 3)
								{
									i[j] = Convert.ToInt32(Subs,10);
								}
							
								j++;
								
							}
						
							po = new Point();
							po.X = i[0];
							po.Y = i[1];
							oneSt.addPoint(po,0);
							//	oneSt.addRecognitionAngle((double)i[2]);
						}
						else if(Substring.StartsWith("|"))//zank ki nam oznacuje zacetek barve in sirine pen-a
						{	
							bool b = true;
						

							foreach(string Subs in Substring.Split(delemeter2))
							{
								if(b)
								{
									string str2;
									str2 = Subs.Remove(0,1);
									str2.Trim();
									this.statusBarPanel1.Text = str2;
									b = false;
									oneSt.addColor(Color.FromName(str2));
						
								}
								else
								{	
									Subs.Trim();
									oneSt.addWidth(Convert.ToInt32(Subs));
									resitveStroki.addStroke(oneSt);
									//	allStrokes.addStroke(oneSt);
									b = true;

									break;
								}
								
							}
							break;	//skocimo iz zanke, ker je v datoteki samo e znak /n	
						}
				
					}
			
					
					
				}
				else
					this.statusBarPanel1.Text = "File pointer is null File->Open !";	
				str1 = reader.ReadLine();
			}while(str1 != null);
			
			this.statusBarPanel1.Text = allStrokes.numberOfStrokes().ToString();
					
			reader.Close();	
			openFileDialog1.Dispose();
			//	Narisi_objekte(allStrokes);
			Narisi_objekte(resitveStroki);

	
		}
		/*-------------------------------------------------------------------------------------------------*/
		/*---------------- SCROLLBAR-----------------------------------------------*/
		private void vScrollBar1_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{	
			

			Point p = new Point();
			p.X = panel2.Location.X;
			p.Y = panel2.Location.Y -e.NewValue+ LastScroll_V;
			LastScroll_V = e.NewValue;
			panel2.Location = p;

		}

		private void hScrollBar1_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
				

			Point p = new Point(panel2.Location.X - e.NewValue+ LastScroll_H ,panel2.Location.Y );
			p.X = panel2.Location.X - e.NewValue+ LastScroll_H;
			p.Y = panel2.Location.Y;
			LastScroll_H = e.NewValue; 
			panel2.Location = p;

		

		
		}
		/*-------------------------------------------------------------------------------------------------------------*/
		/*manjsi popravek da se na panel2 iz mainMenu ne risejo nepricakovane crte */
		private void menuItem1_Popup(object sender, System.EventArgs e)
		{
			lastPoint = Point.Empty;
			
		}

		private void menuItem17_Click(object sender, System.EventArgs e)	//Form-a za Set_Corner
		{
			s = new Set_corner();
			s.Show();
			s.Closing += new System.ComponentModel.CancelEventHandler(this.SetCornerClosing);
		
		}

		private void SetCornerClosing(object sender, System.ComponentModel.CancelEventArgs e)
		{

			//rr = s.returnRecognizer();
		
		}

		private void menuItem18_Click(object sender, System.EventArgs e) //Form-a za Set_Line
		{
			Set_line line = new Set_line();
			line.Show();

		}

		private void menuItem20_Click(object sender, System.EventArgs e) //Form-a za Draw_Graph
		{
			Draw_graph dg = new Draw_graph();
			dg.Show();
			dg.inicialise(allStrokes);
			
		}

		private void menuItem22_Click(object sender, System.EventArgs e) //Set_Forces
		{
			Set_Forces setF = new Set_Forces();
				
			stopSimSileThread();
			
			setF.Show();



            		
		}

		/*-------------------------------------------------------------------------------------------------------------*/
		//IZBIRA POSTAVITVE GUI-ja GLEDE NA TO ALI SI LEVIAR ALI DESNIAR
		
		//postavitev za levicarje
		private void menuItem19_Click(object sender, System.EventArgs e) //View Left_Hand
		{
			if(this.menuItem19.Checked == false)
			{
				Point p = new Point();
				p.X = this.panel2.Location.X - this.panel6.Size.Width;
				p.Y = this.panel2.Location.Y;
				this.panel2.Location = p;						//panel kjer risemo

				p.X = this.panel4.Location.X - this.panel6.Size.Width;
				p.Y = this.panel4.Location.Y;
				this.panel4.Location = p;						//H_scrollbar

				p.X = this.panel5.Location.X - this.panel6.Size.Width;
				p.Y = this.panel5.Location.Y;
				this.panel5.Location = p;						//V_scrollbar

				p.X = Form1.ActiveForm.Size.Width - this.panel6.Size.Width-8;
				p.Y = 0;
				this.panel6.Location = p;	//panel z gumbi za debelino in barvo
				this.panel6.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
					| System.Windows.Forms.AnchorStyles.Right)));

				this.menuItem19.Checked = true;
				this.menuItem21.Checked = false;
			}
			
	
		}

		//Postavitev za desnicarje
		private void menuItem21_Click(object sender, System.EventArgs e)//View->Right_Hand
		{

			if(this.menuItem21.Checked == false)
			{
				Point p = new Point();
		
				
				p.X = this.panel2.Location.X + 	this.panel6.Size.Width;
				p.Y = this.panel2.Location.Y;
				this.panel2.Location = p;								//panel kjer risemo

				p.X = this.panel4.Location.X + 	this.panel6.Size.Width;
				p.Y = this.panel4.Location.Y;
				this.panel4.Location = p;						//H_scrollbar

				p.X = this.panel5.Location.X + 	this.panel6.Size.Width;
				p.Y = this.panel5.Location.Y;
				this.panel5.Location = p;							//V_scrollbar

				p.X = 0;
				p.Y = 0;
				this.panel6.Location = p;	//panel z gumbi za debelino in barvo
				this.panel6.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
					| System.Windows.Forms.AnchorStyles.Left)));
			
				this.menuItem21.Checked = true;
				this.menuItem19.Checked = false;
			}
		}

		private void button18_Click(object sender, System.EventArgs e)
		{
			if(!Start_Stop_Force_Simulation)
			{
				
				simSileThread = new Thread(new ThreadStart(simulirajSile));
				simSileThread.Start();
				Start_Stop_Force_Simulation = true;
				narisiMrezo = false;
				this.menuItem23.Checked = false;
				g.Clear(Color.White);
				
			}
			else
			{
			
			//  simSileThread.Suspend();
				simSileThread.Abort();
				Start_Stop_Force_Simulation = false;
				

				//	Narisi_objekte1(resitveStroki);
			}
		

		}


		private void stopSimSileThread()
		{
		
			if(simSileThread.IsAlive)
			{
				simSileThread.Abort();
				while(simSileThread.IsAlive);

				Narisi_objekte1(resitveStroki);
				Start_Stop_Force_Simulation = false;
					
			}
		
		}

		private void menuItem23_Click(object sender, System.EventArgs e)	//Narisi mrezo v Narisi_objekte1(...)
		{
			if(!simSileThread.IsAlive)
			{
				if(narisiMrezo)
				{
					narisiMrezo = false;
					g.Clear(Color.White);
					menuItem23.Checked = false;
					Narisi_objekte1(resitveStroki);
				}
				else 
				{
					narisiMrezo = true;
					menuItem23.Checked = true;
					g.Clear(Color.White);
					Narisi_objekte1(resitveStroki);
				}
			}
		
		}

		private void menuItem3_Click(object sender, System.EventArgs e)//Settings -> Set_Grid
		{
			Set_Grid setG = new Set_Grid();
			stopSimSileThread();
			setG.Show();


		}

		private void menuItem24_Click(object sender, System.EventArgs e) //Set Recognizer
		{
			SetRecognizer sr = new SetRecognizer();
			sr.Show();
		}

		private void menuItem25_Click(object sender, System.EventArgs e) //Tools->Test input data
		{
			Test_data td = new Test_data();
			td.Show();

		}

		private void menuItem26_Click(object sender, System.EventArgs e)
		{
			InsertText it = new InsertText();
				it.Show();
		}

		private void menuItem27_Click(object sender, System.EventArgs e)
		{
			if(menuItem27.Checked)
			{
				menuItem27.Checked = false;
			}
			else
				menuItem27.Checked = true;
		}

	

	

		/*-------------------------------------------------------------------------------------------------------------*/
	
		
  						
	}
}
