/*
Copyright (c) 2004, Marjan Punik, Mate Betek, Bla Kurent

All rights reserved.

Redistribution and use in source and binary forms, with or without modification, 
are permitted provided that the following conditions are met:

* Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
* Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in
the documentation and/or other materials provided with the
distribution.
* Neither the name of the Faculty of Computer and Information Science 
nor the names of its contributors may be used to endorse or promote
products derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR 
IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND 
FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR 
CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL 
DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, 
DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER 
IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT 
OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/


using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;

namespace symmetry
{
	/// <summary>
	/// Summary description for Set_line.
	/// </summary>
	public class Set_line : System.Windows.Forms.Form
	{
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem menuItem4;
		private System.Windows.Forms.MenuItem menuItem5;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private bool mouseDown = false;
		private int objectDrawn = 0;
		private Point lastPoint = Point.Empty;
		private Graphics g;
		private Pen p;
		private Stroke1 oneSt =  new Stroke1();
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.SaveFileDialog saveFileDialog1;
		private System.Windows.Forms.Label label1;
		private Strokes1 allSt = new Strokes1();


		public Set_line()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Set_line));
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.menuItem4 = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.panel1 = new System.Windows.Forms.Panel();
			this.saveFileDialog1 = new System.Windows.Forms.SaveFileDialog();
			this.label1 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1,
																					  this.menuItem7});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3,
																					  this.menuItem4,
																					  this.menuItem6,
																					  this.menuItem5});
			this.menuItem1.Text = "File";
			this.menuItem1.Popup += new System.EventHandler(this.menuItem1_Popup);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "New";
			this.menuItem2.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "Next";
			this.menuItem3.Click += new System.EventHandler(this.menuItem3_Click);
			// 
			// menuItem4
			// 
			this.menuItem4.Index = 2;
			this.menuItem4.Text = "Save as ..";
			this.menuItem4.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 3;
			this.menuItem6.Text = "-";
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 4;
			this.menuItem5.Text = "Exit";
			this.menuItem5.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 1;
			this.menuItem7.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem8});
			this.menuItem7.Text = "Edit";
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 0;
			this.menuItem8.Text = "Undo";
			this.menuItem8.Popup += new System.EventHandler(this.menuItem1_Popup);
			this.menuItem8.Click += new System.EventHandler(this.menuItem8_Click);
			// 
			// panel1
			// 
			this.panel1.BackColor = System.Drawing.Color.White;
			this.panel1.Location = new System.Drawing.Point(24, 72);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(536, 344);
			this.panel1.TabIndex = 0;
			this.panel1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseUp);
			this.panel1.Paint += new System.Windows.Forms.PaintEventHandler(this.panel1_Paint);
			this.panel1.MouseMove += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseMove);
			this.panel1.MouseDown += new System.Windows.Forms.MouseEventHandler(this.panel1_MouseDown);
			// 
			// saveFileDialog1
			// 
			this.saveFileDialog1.Filter = "Text Files (*.txt)|*.txt|All files (*.*)|*.*;";
			// 
			// label1
			// 
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 15F, ((System.Drawing.FontStyle)((System.Drawing.FontStyle.Bold | System.Drawing.FontStyle.Italic))), System.Drawing.GraphicsUnit.Point, ((System.Byte)(238)));
			this.label1.Location = new System.Drawing.Point(32, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(528, 40);
			this.label1.TabIndex = 1;
			this.label1.Text = "Please draw a line between two rectangles";
			// 
			// Set_line
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(600, 437);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.panel1);
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Menu = this.mainMenu1;
			this.Name = "Set_line";
			this.Text = "Set_line";
			this.ResumeLayout(false);

		}
		#endregion

		

		private void panel1_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
			if(g == null)		
			{
				g = panel1.CreateGraphics();
				p = new Pen(Color.FromName("Black"));
				p.Width = 2;
				p.EndCap = System.Drawing.Drawing2D.LineCap.Round;
				p.LineJoin = LineJoin.Round;
				this.Controls.Add(panel1);
				

			}

			p.Color = Color.FromName("Red");
			g.DrawRectangle(p,50,150,30,30);
			g.DrawRectangle(p,450,150,30,30);
			p.Color = Color.FromName("Black");


		}

		private void panel1_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
		
		
			if(((e.X >= 50 && e.X <= 80)&& (e.Y >= 150 && e.Y <= 180))||	//samo ce zadanemo v kvadratek lahko zacnemo risat
				((e.X >= 450 && e.X <= 480)&& (e.Y >= 150 && e.Y <= 180)))
				mouseDown = true;
		
			
			if(objectDrawn == 1)
			{
				objectDrawn++;
			}
		}

		private void panel1_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			
			if((lastPoint.Equals(Point.Empty))) 
				lastPoint = new Point(e.X,e.Y);
				
			if(mouseDown && (e.Button == MouseButtons.Left)&& (objectDrawn == 0))
			{
				Point pMousePos = new Point(e.X,e.Y);
			
			
				oneSt.addPoint(pMousePos,0);

				g.DrawLine(p,pMousePos,lastPoint);
													
			}
			lastPoint = new Point(e.X,e.Y);

				
		
		}

		private void panel1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
		
			if(objectDrawn == 0 && mouseDown == true)
			{
				objectDrawn ++;
				oneSt.addWidth(2);
				oneSt.addColor(p.Color);
				allSt.addStroke(oneSt);
				g.DrawRectangle(p,50,150,30,30);
				g.DrawRectangle(p,450,150,30,30);
			}
			mouseDown = false;
		}

		private void menuItem5_Click(object sender, System.EventArgs e)//File -> exit
		{
           Set_line.ActiveForm.Close();	
		}

		private void menuItem4_Click(object sender, System.EventArgs e) //File ->Save as
		{
			saveFileDialog1.ShowDialog();
			saveFileDialog1.DefaultExt = ".txt";
			saveFileDialog1.AddExtension = true;
		}

	
		private void saveFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)//File -Save As..
		{
			int i = 0;
			int j = 0;
			Point po;
			Stroke1 st = null;
			StreamWriter writer;
		
			writer = new StreamWriter(saveFileDialog1.FileName,true);
		
								
			if((allSt.numberOfStrokes())> 0)
			{
				
				for(j = 0;j < allSt.numberOfStrokes();j++)
				{	
					st = (Stroke1)allSt.returnStrokeObject(j);
					for(i = 0;i < st.numberOfPoints();i++)
					{
						po = st.returnElement(i);
						writer.Write(po.X.ToString()+","+po.Y.ToString()+";");
				
					}
					writer.Write("|");
					writer.Write(st.returnColor().Name+",");
					writer.Write(st.returnWidth().ToString()+";"); 
					writer.Write(writer.NewLine);
					
				}
			}
			
				
		
					
			writer.Close();	
			saveFileDialog1.Dispose();
		}
		
		private void menuItem8_Click(object sender, System.EventArgs e) //Edit ->Undo
		{
			g.Clear(Color.White);
			p.Color = Color.FromName("Red");
			g.DrawRectangle(p,50,150,30,30);
			g.DrawRectangle(p,450,150,30,30);
			p.Color = Color.FromName("Black");
			allSt.clearLastStroke();
			objectDrawn = 0;
		}

		

		private void menuItem1_Popup(object sender, System.EventArgs e)//poprava mainMenu
		{
			lastPoint = Point.Empty;
		}

	
		private void menuItem2_Click(object sender, System.EventArgs e)//File -> New
		{
			g.Clear(Color.White);
			p.Color = Color.FromName("Red");
			g.DrawRectangle(p,50,150,30,30);
			g.DrawRectangle(p,450,150,30,30);
			p.Color = Color.FromName("Black");
			p.Width = 2;
			allSt.clearStrokes();
			allSt = new Strokes1();
			oneSt = new Stroke1();
			objectDrawn = 0;

		
		}

		private void menuItem3_Click(object sender, System.EventArgs e)//File -> Next
		{
			g.Clear(Color.White);
			p.Color = Color.FromName("Red");
			g.DrawRectangle(p,50,150,30,30);
			g.DrawRectangle(p,450,150,30,30);
			p.Color = Color.FromName("Black");
			p.Width = 2;
			oneSt = new Stroke1();
			objectDrawn = 0;
		}
			
	}
}
