using System;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Threading;

namespace symmetry
{
	/// <summary>
	/// Summary description for SubDivision.
	/// </summary>
	public class SubDivision
	{
		public int subSampleSize=3; //stevilo tock, ki jih subdivision obdeluje na enkrat
		
		
		public SubDivision()
		{
			//
			// TODO: Add constructor logic here
			//
		}

	

		public  Stroke1 subdivision(Stroke1 str1, int numOfLoops)
		{
			ArrayList subList = new ArrayList();
			ArrayList newList = new ArrayList();
			ArrayList tempList = new ArrayList();
			ArrayList returnList = new ArrayList();
			PointF pt1,pt2,ptT,pF = new PointF();
			Point pI1 = new Point();
			Point pI2 = new Point();
			Point pItemp = new Point();

			double dX,dY;
			int insertIndex;
			//Console.WriteLine("Zaenjam subdivision");

			//subdivision delamo na nekaj tockah naenkrat
			for (int i1=0; i1 < str1.markedCornersL.Count - subSampleSize + 1; i1= i1 + subSampleSize -1)
			{
				subList.Clear();
				
				for (int k=i1; k < i1 + subSampleSize; k++) //skopiramo en del 'str1' v 'subList'
				{
					pItemp=(Point)str1.markedCornersL[k]; //ostr1 ima koordinate tock tipa 'int'
					pF.X=(float)pItemp.X; pF.Y=(float)pItemp.Y;
					subList.Add(pF);
				}

				for (int i2=0; i2 < numOfLoops; i2++) //stevilo ponovitev operacije 'subdivision'
				{
					//------------------prvic generiramo vmesne tocke--------------------------------------
					newList.Clear();
					for (int k=0; k < subList.Count; k++) //skopiramo 'subList' v  'newList'
						newList.Add((PointF)subList[k]);

					for (int k1=0; k1 < subList.Count-1; k1++) //'newList' je 'subList' z vmesnimi tockami
					{
						pt1=(PointF)subList[k1];
						pt2=(PointF)subList[k1+1];
						dX=(pt1.X + pt2.X)/2;
						dY=(pt1.Y + pt2.Y)/2;
						PointF tNew = new PointF((float)dX,(float)dY); //kreiramo novo vmesno tocko					

						for (insertIndex=0; insertIndex < newList.Count; insertIndex++) //poiscemo mesto v 'newList', kamor dodamo novo tocko
						{
							//konverzija********************
							pt1=(PointF)newList[insertIndex]; //tocke primerjamo do natancnosti integer
							pt2=(PointF)subList[k1];	
							pI1.X=(int)pt1.X; pI1.Y=(int)pt1.Y;
							pI2.X=(int)pt2.X; pI2.Y=(int)pt2.Y;

							if (pI1==pI2) break;
						} //for k2
						newList.Insert(insertIndex+1,tNew); //v seznam 'newList' vstavimo novo tocko
					} //for k1 

					subList.Clear();
					for (int k=0; k < newList.Count; k++) //skopiramo 'newList' v subList' 
						subList.Add((PointF)newList[k]);

					//--------prvic generiramo tocke^^^^^^------------------------------------------------

					//--------drugo generiranje vmesnih tock----------------------------------------------
					
					newList.Clear();
					for (int k=0; k < subList.Count; k++) //skopiramo 'subList' v  'newList'
						newList.Add((PointF)subList[k]);

					for (int k1=0; k1 < subList.Count-1; k1++) //'newList' je 'subList' z vmesnimi tockami
					{
						pt1=(PointF)subList[k1];
						pt2=(PointF)subList[k1+1];
						dX=(pt1.X + pt2.X)/2;
						dY=(pt1.Y + pt2.Y)/2;
						PointF tNew = new PointF((float)dX,(float)dY); //kreiramo novo vmesno tocko					

						for (insertIndex=0; insertIndex < newList.Count; insertIndex++) //poiscemo mesto v 'newList', kamor dodamo novo tocko
						{
							//konverzija********************
							pt1=(PointF)newList[insertIndex];
							pt2=(PointF)subList[k1];
							pI1.X=(int)pt1.X; pI1.Y=(int)pt1.Y;
							pI2.X=(int)pt2.X; pI2.Y=(int)pt2.Y;
							if (pt1==pt2) break;
						} //for k2
						newList.Insert(insertIndex+1,tNew); //v seznam 'newList' vstavimo novo tocko
					} //for k1 

					subList.Clear();
					for (int k=0; k < newList.Count; k++) //skopiramo 'newList' v 'subList' 
						subList.Add((PointF)newList[k]);
										
					//---------------drugo generiranje tock ^^^^^-------------------------------------------
					
					//---------------------pregled trojk----------------------------------------------------
					for (int k1=0; k1 < subList.Count-2; k1++) //pregledamo vse trojke v 'subList' in pregledamo vmesne tocke
					{
						pt1=(PointF)subList[k1];
						pt2=(PointF)subList[k1+2];
						dX=(pt1.X + pt2.X)/2;
						dY=(pt1.Y + pt2.Y)/2;
						PointF tNew = new PointF((float)dX,(float)dY); //kreiramo novo vmesno tocko
						
						pt1=tNew;
						pt2=(PointF)subList[k1+1];
						pI1.X=(int)pt1.X; pI1.Y=(int)pt1.Y;
						pI2.X=(int)pt2.X; pI2.Y=(int)pt2.Y;
						
						if (pI1 != pI2) //nasli smo novo tocko !!
						{
							//sedaj iz seznama 'newList' brisemo tri in dodamo eno novo tocko	
							ptT=(PointF)subList[k1+1];
							//Console.WriteLine("Stara: ({0};{1}), nova: ({2};{3})",ptT.X,ptT.Y,tNew.X,tNew.Y);
							// 2. V 'newList' poiscemo tocke z indeksom 'k1','k1+1' in 'k1+2' in jih zbrisemo
							tempList.Clear();
							for (int k=0; k < newList.Count; k++) //pripravimo si pomozen seznam
								tempList.Add((PointF)newList[k]);

							for (int h=0; h < newList.Count-2; h++) //  spremenim 'newList' (DODAN nov pogoj!!)
							{
								pt1=(PointF)newList[h];
								pt2=(PointF)subList[k1];
								pI1.X=(int)pt1.X; pI1.Y=(int)pt1.Y;
								pI2.X=(int)pt2.X; pI2.Y=(int)pt2.Y;

								if (pI1==pI2) //nasli smo jo
								{									
									newList.Insert(h,tNew);
									newList.RemoveAt(h+1);
									newList.RemoveAt(h+1);
									newList.RemoveAt(h+1);
									//tempList.RemoveAt(h);
									
									break;					
								}
								
							} //for h
							
						
						} //if nova vmesna tocka razlicna od stare
												
					} //for k1 (vse trojke v seznamu 'subList') -------------------------------------

					subList.Clear();
					for (int k=0; k < newList.Count; k++) //skopiramo 'newList' v 'subList' 
						subList.Add((PointF)newList[k]);
					
				} //for i2 - ponovitve za 'subdivision'
			
				for (int k=0; k < subList.Count; k++) //skopiramo 'subList' v koncno seznam
					returnList.Add((PointF)subList[k]);

			} //for i1 -> vsi skupki tock
			
			//-----------------------------------KONEC----------------------------------------------------
			
			str1.markedCornersL.Clear();
			for (int k=0; k < returnList.Count; k++) // 'returnList' skopiramo nazaj v 'markedCornersList'
			{
				pF=(PointF)returnList[k]; //konverzija iz tock 'float' v 'int'
				pItemp.X =(int)pF.X; pItemp.Y=(int)pF.Y;
				str1.markedCornersL.Add(pItemp);
			}
			//Console.WriteLine("Subdivision zakljuen!");
			return str1;
			
		} //subdivision

	}
}
