using System;
namespace symmetry
{
	
	/// <summary> Represents a spring in a force simulation.
	/// 
	/// </summary>
	/// <version>  1.0
	/// </version>
	/// <author>  <a href="http://jheer.org">Jeffrey Heer</a> prefuse(AT)jheer.org
	/// </author>
	public class Spring
	{
		public static SpringFactory Factory
		{
			get
			{
				return s_factory;
			}
			//
			
		}
		//UPGRADE_NOTE: The initialization of  's_factory' was moved to static method 'edu.berkeley.guir.prefusex.force.Spring'. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1005"'
		private static SpringFactory s_factory;
		
		public Spring(ForceItem fi1, ForceItem fi2, float k, float len)
		{
			item1 = fi1;
			item2 = fi2;
			coeff = k;
			length = len;
		} //
		public ForceItem item1;
		public ForceItem item2;
		public float length;
		public float coeff;
		
		public sealed class SpringFactory
		{
			public SpringFactory()
			{
				InitBlock();
			}
			private void  InitBlock()
			{
				//UPGRADE_ISSUE: Class hierarchy differences between 'java.util.ArrayList' and 'System.Collections.ArrayList' may cause compilation errors. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1186"'
				springs = new System.Collections.ArrayList();
			}
			private int maxSprings = 10000;
			//UPGRADE_ISSUE: Class hierarchy differences between 'java.util.ArrayList' and 'System.Collections.ArrayList' may cause compilation errors. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1186"'
			//UPGRADE_NOTE: The initialization of  'springs' was moved to method 'InitBlock'. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1005"'
			private System.Collections.ArrayList springs;
			
			public Spring getSpring(ForceItem f1, ForceItem f2, float k, float length)
			{
				//UPGRADE_TODO: The equivalent in .NET for method 'java.util.ArrayList.size' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
				if (springs.Count > 0)
				{
					//UPGRADE_TODO: The equivalent in .NET for method 'java.util.ArrayList.remove' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
					//UPGRADE_TODO: The equivalent in .NET for method 'java.util.ArrayList.size' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
					Spring s = (Spring) springs[springs.Count - 1];
				    springs.RemoveAt(springs.Count - 1);
					s.item1 = f1;
					s.item2 = f2;
					s.coeff = k;
					s.length = length;
					return s;
				}
				else
				{
					return new Spring(f1, f2, k, length);
				}
			} //
			public void  reclaim(Spring s)
			{
				s.item1 = null;
				s.item2 = null;
				//UPGRADE_TODO: The equivalent in .NET for method 'java.util.ArrayList.size' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
				if (springs.Count < maxSprings)
				{
					//UPGRADE_TODO: The equivalent in .NET for method 'java.util.ArrayList.add' may return a different value. 'ms-help://MS.VSCC.2003/commoner/redir/redirect.htm?keyword="jlca1043"'
					springs.Add(s);
				}
			} //
		}
		static Spring()
		{
			s_factory = new SpringFactory();
		}
	} // end of class Spring
}